import java.net.*;
import java.util.*;
import java.io.*;
//import java.awt.Toolkit;

abstract class ControllerThd extends Thread implements Definitions 
{

	int m_agent_type;
	int m_current_state;
	int m_current_time;
        int m_prev_time;
	int m_execute_base=-1;
	boolean assignments_done=false;        //If in a simulation cycle an agent is assigned to a job this is set to true
	double reward;
	ActionHistoryItem [] m_action_history;
	WorldModel m_world_model;
	ControllerLearningComponent m_learner;
	IO m_io;
	MessageParser m_msgParser;
	InetAddress m_address;

	int m_sent_message_count;
	int m_rcvd_message_count;
	int m_max_send_msg;
	int m_max_rcv_msg;

	Vector m_agents_requesting_job;        //The agents that have sent MSG_REQUEST
	Vector m_heard_messages;
	Vector m_unreported_roads;
	Vector m_unreported_clear;
	Vector m_unreported_civid;
        Vector m_cleared_roads;                 //The roads stored here are not updated as blocked later
        Vector m_agents_not_having_job;
        Vector m_pending_assignments;
	Hashtable m_civilian_updates;
	Hashtable m_civilians_pos_known;
        //Toolkit m_toolkit;

	int m_id;
	byte m_agent_index;
	byte m_target_index;
	int m_target_saved;                    //Used when updating the status of objects
	int m_target_ruined;                   //Used when updating the status of objects
	int the_action;
	int m_num_saveable_targets;
        int m_available_agents;
	int my_training_run_num;
        double m_accept_probability;
        
	String m_filename;
        Building reported_building;
				
  	ControllerThd(int agent_type, String inetaddr, int training_run_num)
	{
		
	try{
		int i;
		my_training_run_num=training_run_num;
		m_agent_type=agent_type;
		m_current_time=0;
                m_prev_time=0;
		m_action_history=new ActionHistoryItem[DEF_NUM_TICKS+10];
		for(i=0;i<DEF_NUM_TICKS+10;i++)
		{
			m_action_history[i]=new ActionHistoryItem();
		}
	
		m_world_model=new WorldModel();             
		m_learner=new ControllerLearningComponent();
		m_address=InetAddress.getByName(inetaddr);
		m_io=new IO(m_address,DEF_SEND_PORT);	
		m_msgParser=new MessageParser();
		m_agents_requesting_job=new Vector();
		m_heard_messages=new Vector();
		m_unreported_roads=new Vector();
		m_unreported_clear=new Vector();
		m_unreported_civid=new Vector();
                m_cleared_roads = new Vector();
		m_civilian_updates=new Hashtable();
		m_civilians_pos_known=new Hashtable();
                m_agents_not_having_job = new Vector();
                m_pending_assignments = new Vector();
                //m_toolkit = new Toolkit();         
       		m_sent_message_count=0;
		m_rcvd_message_count=0;
		//m_max_send_msg=MAX_MSG_SEND;  //CHANGED FOR 2003
		//m_max_rcv_msg=MAX_MSG_RCV;
		m_num_saveable_targets=-1;
                m_accept_probability=def_center_accept_probability;
		setAgentSpecificConstants();
		
	}catch(Exception e){}

	}
	
	abstract void setAgentSpecificConstants();
	

	void assignExecuteMessages()
	{
		Integer temp_index;
		int execute_message=m_execute_base;
		int minimum_agent_id=MY_MAXINT;
		int i;
		int agents_assigned=0;
		int agents_max=m_world_model.the_world[m_agent_index].size();
		SimObject AgentObject;
		
		Iterator it=m_world_model.the_world[m_agent_index].keySet().iterator();

		while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			if (temp_index.intValue()<minimum_agent_id)
				minimum_agent_id=temp_index.intValue();
                                
                        m_agents_not_having_job.add(temp_index);
		}
	
                System.out.println("***********" + minimum_agent_id + "**********************");
		AgentObject= (SimObject)m_world_model.the_world[m_agent_index].get(new Integer(minimum_agent_id));
		((MovingObject)AgentObject).m_execute_message=execute_message;
		agents_assigned++;
		
		for (i=minimum_agent_id+1; agents_assigned<agents_max;i++)
		{
			if (m_world_model.the_world[m_agent_index].containsKey(new Integer(i)))
			{
				execute_message++;
				AgentObject= (SimObject)m_world_model.the_world[m_agent_index].get(new Integer(i));
				((MovingObject)AgentObject).m_execute_message=execute_message;
				agents_assigned++;
				
				if (GEN_LOGGING) m_msgParser.writeMyFile(m_filename,"M ID: " + AgentObject.m_id + " M_EXECUTE: " + ((MovingObject)AgentObject).m_execute_message);		
				System.out.println ("AgentObject.m_id: " + AgentObject.m_id + " M_EXECUTE: " + ((MovingObject)AgentObject).m_execute_message);		
			}
		}	
	

	}


	public void run()
	{
		int [] current_msg_body;
                
		m_learner.readQvalues();
                //m_learner.printQvalues();
                
		m_id=(int)m_io.connectToKernel(m_agent_type,m_world_model);
		m_filename="ControllerLog"+m_id+".txt";
		m_world_model.setFilename(m_filename);
		m_learner.set_log_filename(m_filename, m_agent_index);
		m_max_rcv_msg=m_world_model.the_world[m_agent_index].size()* 2 ;
		m_max_send_msg=m_world_model.the_world[m_agent_index].size()* 2 ;
                //assignExecuteMessages();
		System.out.println("Agent type: "+ m_agent_type + "My id is:" + m_id+ "agent_type: " + m_agent_index);
		if (C_LOGGING)m_msgParser.writeMyFile(m_filename,"Agent type: "+ m_agent_type + "My id is:" + m_id+ "agent_type: " + m_agent_index);
	              
		while(m_current_time<DEF_NUM_TICKS) //+my_training_run_num)
		{
				current_msg_body=m_io.receiveLongPacket();
				if (current_msg_body==null)
					continue;
                                //m_prev_time=m_current_time;             //Store the time to track cycles        
				handleMessage(current_msg_body);
				
				
			//oldest:if (m_current_time>=STEPS_AGENT_FREEZED && !assignments_done && m_current_time>=my_training_run_num && availableAgents()>0 && numOfSaveableTargets(m_target_index)>0)
                        //TEST CASE: FIREFIGHTER DOES NOT PREEMPT
                        //if ((m_target_index!=WORLD_MODEL_BUILDING_INDEX) && m_current_time>=STEPS_AGENT_FREEZED && !assignments_done  && availableAgents()>0 && numOfSaveableTargets(m_target_index)>0)
                        if (m_current_time>=STEPS_AGENT_FREEZED && !assignments_done  && availableAgents()>3 && numOfSaveableTargets(m_target_index)>0)
			{
                                        //This loop is executed until an assignment is done in a cycle
                                        //Saveable targets is only calculated here. No need to decrement the vector size within one cycle, since it is updated in the beginning of  each cycle.
					m_num_saveable_targets = numOfSaveableTargets(m_target_index);
                                        m_available_agents = availableAgents();
					//if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Number of targets" + m_num_saveable_targets + " available agents: " + m_available_agents + "time:" + m_current_time);
                                     
                                     
						the_action=m_learner.decideOnAction(m_current_state);
						//m_msgParser.writeMyFile(m_filename,"action decision done " + the_action + " the time" + m_current_time);
					
						switch (the_action)
						{		
							case CONTROLLER_URGENT_FIRST:case CONTROLLER_URGENT_2_BY_2: case CONTROLLER_URGENT_3_BY_3:
	     					                
                                                                if (m_available_agents>=(-URGENT_BASE + the_action+1))
							                assignMostUrgentJobToClosest((int)(-URGENT_BASE + the_action+1));
                                                                else
                                                                {
                                                                        assignMostUrgentJobToClosest(m_available_agents);
                                                                        //System.out.println("Smaller version 1");       
                                                                }        
							break;
							case CONTROLLER_CLOSEST_FIRST:case CONTROLLER_CLOSEST_2_BY_2: case CONTROLLER_CLOSEST_3_BY_3:
							         /*
                                                                 int x;
                                                                 
                                                                 x = m_available_agents;
                                                                 x /= m_num_saveable_targets;
                                                                 //if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"x" + x + " agents " + m_available_agents + " m_num_saveable_targets " + m_num_saveable_targets);
							         if (x>=(-CLOSEST_BASE + the_action+1))
                                                                 
							                assignEachAgentToClosest((int)(-CLOSEST_BASE + the_action+1));
                                                                 else if (x==0)
                                                                 {
                                                                        assignEachAgentToClosest((int)1);
                                                                 }
                                                                 else
                                                                 {
                                                                        assignEachAgentToClosest(x);
                                                                        //System.out.println("Smaller version 2");       
                                                                 } 
                                                                 
                                                                 */
                                                                 
                                                                if (m_available_agents>=(-CLOSEST_BASE + the_action+1))
							                assignEachJobToClosest((int)(-CLOSEST_BASE + the_action+1));
                                                                else
                                                                {
                                                                        assignEachJobToClosest(m_available_agents);
                                                                        //System.out.println("Smaller version 1");       
                                                                }    
							break;
							case CONTROLLER_LIGHTEST_1_BY_1:case CONTROLLER_LIGHTEST_2_BY_2: case CONTROLLER_LIGHTEST_3_BY_3:
						
                                                        	if (m_available_agents>=(-LIGHTEST_BASE + the_action+1))
							                assignLightestJobToClosest((int)(-LIGHTEST_BASE + the_action+1));
                                                                else
                                                                {
                                                                        assignLightestJobToClosest(m_available_agents);
                                                                        //System.out.println("Smaller version 3");       
                                                                }       
							break;
							default:
							if (C_LOGGING)m_msgParser.writeMyFile(m_filename,"case match etmedi");
							break;
						}//end of switch		
				
			 }//end of time>5	
                         else                                 
                         {        
                                       //if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Time: " + m_current_time);
                                       while (withinSayLimits() && m_pending_assignments.size()>0)
                                       {
                                                AssignmentItem logged_assignment;
                                                logged_assignment=(AssignmentItem) m_pending_assignments.remove(0);
                                                //m_io.sendAK_TELL(m_id, logged_assignment.agent_msg, logged_assignment.target_id);
						m_io.sendAK_TELL(m_id, logged_assignment.agent_msg, logged_assignment.target_id);
                                                //if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Sent another logged assignment time:" + m_current_time);
                                                increaseSaidNum();
                                       }
                                       
                                        //Reporting fiery building
                                        if(withinSayLimits() && m_world_model.buildings_tobe_reported.size()>0)
						{
                                                        reported_building = ((Building)m_world_model.buildings_tobe_reported.remove(0));
                                                        reported_building.m_fire_reported=1;
                                                        m_io.sendAK_TELL(m_id,MSG_FIERY_BUILDING ,reported_building.m_id);
							increaseSaidNum();
                                                        //System.out.println("Building " + reported_building.m_id + "reported by controller: " + m_id);
						}	
			              
					//Reporting the blocked roads
					if(withinSayLimits() && m_unreported_roads.size()>0)
						{
							Integer road_to_report;
							road_to_report=(Integer)m_unreported_roads.remove(0);
							m_io.sendAK_TELL(m_id, MSG_CLEAR, road_to_report.intValue());   
							increaseSaidNum();
						}	
			
					//Reporting the clear roads	
					if (withinSayLimits() && m_unreported_clear.size()>0)
						{
							Integer road_cleared;
							road_cleared=(Integer)m_unreported_clear.remove(0);
							m_io.sendAK_TELL(m_id, MSG_ROAD_CLEARED, road_cleared.intValue());   
							increaseSaidNum();
						}
					//Reporting civilians (only ID)		
					if (withinSayLimits() && m_unreported_civid.size()>0)
						{
							Integer civid_to_report;
							civid_to_report=(Integer)m_unreported_civid.remove(0);
							m_io.sendAK_TELL(m_id, MSG_HELPCIVPENDINGPOS, civid_to_report.intValue());   
							increaseSaidNum();
						}	
				
			              
	       				    //System.out.println("Writing Q values");
	       				    m_learner.writeQvalues();    
                               // try{
                               //   Thread.sleep(5);
                               // }
                               // catch(Exception e){}      
                          } 
		}//end of while
		
		while (true)
                {
                      try {wait();} catch (Exception e){}
                }
	}//end of run


	void handleMessage(int [] full_message)
	{
		int message_type;
		int action_time=-1;
		message_type=m_msgParser.get_msg_type_long_packet(full_message);
		int reward_divisor;

		if (message_type==KA_SENSE) //world information
		{	
			resetHeardSaid();
			assignments_done=false;
			if (full_message[MSG_FORMAT_SENSE_ID]==m_id)				//If the sense message is targeted to you
			{
				m_current_time=(int)full_message[MSG_FORMAT_SENSE_TIME];
				//System.out.println("Time: " + m_current_time + "me:" + m_id);
                               
				if (AMB_LOGGING)m_msgParser.writeMyFile(m_filename,"Time: " + m_current_time + "me:" + m_id);
				
				try{
				m_world_model.parseKA_SENSE(full_message,m_current_time);				//Update world information
				}catch(Exception e){}
				
				m_current_state=m_world_model.get_current_state(m_agent_index, m_agent_type);
				//System.out.println("current state: " + m_current_state + "action:" + the_action);
				if (C_LOGGING)m_msgParser.writeMyFile(m_filename,"current state: " + m_current_state + "action:" +the_action);
                                
                                
                                //if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Agents not having job" + m_agents_not_having_job.size());
					
			}
		} 

		else if (message_type==KA_HEAR)
		{	
			int sender_id=full_message[MSG_FORMAT_HEAR_SENDER_ID];
			if (COMM_LOGGING)m_msgParser.writeMyFile(m_filename,"HEARD MESSAGE" + sender_id);
		
			//Dispatcher listens to everyone, except for itself
			if (sender_id!=m_id )
			{
			
				if (withinHearLimits())
				{
					increaseHeardNum();
					HeardInfo heard=m_msgParser.parseKA_HEAR(full_message);
			
					if (COMM_LOGGING) m_msgParser.writeMyFile(m_filename,"message_detail: " + heard.detail);
					switch (heard.detail)
					{
						case MSG_SUCCESS: case MSG_FAILURE:
						{
						  if (m_world_model.memberOf(m_agent_index,sender_id))
						  {	
                                                        if (!m_agents_not_having_job.contains(new Integer(sender_id)))
                                                        {
						  	       m_agents_not_having_job.add(new Integer(sender_id));           
							       //if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Agents not having job increased 1 ");
                                                        }
                                                        //m_msgParser.writeMyFile(m_filename,"Success/failure mesaji geldi " + heard.subject);
	
							m_world_model.clearAssignedToOf(sender_id,m_agent_index);
							reward_divisor=m_world_model.getRewardDivisor(heard.subject,m_target_index);
							if (reward_divisor==0) 
                                                        {
                                                              reward_divisor=1;
                                                              //m_toolkit.beep();
                                                              System.out.println("Reward divisor 0????");
						        }
                                                        
                                                        
                                                        
							if (heard.detail==MSG_SUCCESS)
                                                        {
								m_world_model.updateWorld(heard.subject,m_target_index,m_target_saved);
							}
                                                        else
							{
                                                                m_world_model.updateWorld(heard.subject,m_target_index,m_target_ruined);
						        }  
							//Find when we have made this assignment
							action_time=find_state_action_time(sender_id,heard.subject);
							//System.out.println("Action time was: " + action_time);

							//If we have found the action
                                                        
							if (action_time>=0 )
							{	
								//System.out.println("response action time is: " +action_time);
								//If more than one agent is assigned to a target, then reward is divided to the number of assignments made
								
                                                                if (m_target_index == WORLD_MODEL_BUILDING_INDEX)
                                                                {
                                                                        reward = ((Building)(m_world_model.the_world[WORLD_MODEL_BUILDING_INDEX].get(new Integer(heard.subject)))).m_buildingAreaTotal/1000;
                                                                        reward /= (double)reward_divisor;
                                                                }
                                                                else
                                                                {
                                                                        reward = (double)JOB_REWARD/(double)reward_divisor;
                                                                }
							        
								//Failure q value is negative
								if (heard.detail==MSG_FAILURE)
								{
									reward=-(reward);
                                                                        if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Failure message arrived to center agent: " + sender_id + " target: " + heard.subject) ; 
								}
                                                                else
                                                                {
                                                                        //m_msgParser.writeMyFile(m_filename,"Success message arrived to center agent: " + sender_id + " target: " + heard.subject + " action " + m_action_history[action_time].action) ; 
                                                                        m_learner.updateQvalues(m_action_history[action_time].state, m_action_history[action_time].action,reward, reward_divisor);
                                                                }
								
								if (C_LOGGING) m_msgParser.writeMyFile(m_filename,"Updated q values");
								
							}
							break;
					 	   }//end of own platoon control
					  	break;
						}
						
					case MSG_NEUTRAL_POS: //received when someone else has saved the job assigned to this agent
						  
						  if (m_world_model.memberOf(m_agent_index,sender_id))
						  {	
                                                        if (!m_agents_not_having_job.contains(new Integer(sender_id)))
        						{
                                                                m_agents_not_having_job.add(new Integer(sender_id));          
							        //if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Agents not having job increased 2 ");
                                                        }
                                                        //m_msgParser.writeMyFile(m_filename,"neutral pos mesaji geldi " + heard.subject);
							m_world_model.clearAssignedToOf(sender_id,m_agent_index);
							//m_world_model.clearAssignedToOf(heard.subject,m_target_index);
						
							m_world_model.updateWorld(heard.subject,m_target_index,m_target_saved);	
						  }
						
					break;	
					case MSG_NEUTRAL_NEG: //received when someone else has saved the job assigned to this agent
						  
						  if (m_world_model.memberOf(m_agent_index,sender_id))
						  {	
	                                                if (!m_agents_not_having_job.contains(new Integer(sender_id)))
                                                        {
        						  	m_agents_not_having_job.add(new Integer(sender_id));                                               
                                                                //if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Agents not having job increased 3 ");
                                                        }
        						//m_msgParser.writeMyFile(m_filename,"neutral neg mesaji geldi " + heard.subject);
							m_world_model.clearAssignedToOf(sender_id,m_agent_index);
							//m_world_model.clearAssignedToOf(heard.subject,m_target_index);
						
							m_world_model.updateWorld(heard.subject,m_target_index,m_target_ruined);	
						  }
						
					break;	
					case MSG_REQUEST:
					{
					if (m_world_model.memberOf(m_agent_index,sender_id))
					  {	
					  
					  	//Updating the position of the requester
					  	SimObject agentObject;		
						agentObject=m_world_model.getObjectbyId(sender_id, m_agent_index);
						((MovingObject)agentObject).m_position=heard.subject;
						//m_world_model.clearAssignedToOf(sender_id,m_agent_index);
                                                //ClearJobsAssignedTo(sender_id);
                                                
                                                //Sometimes the command arrives late to the agent and it requests job... 
                                                //However sometimes it never arrives the agent, or agents response never arrives to dispatcher
                                                //Still our dispatcher waits for an answer from an assigned agent
						if (agentObject.m_assignedTo<=0)
						{  
						  if (!m_agents_requesting_job.contains(new Integer(sender_id)))
						  	m_agents_requesting_job.add(new Integer(sender_id));
                                                        
                                                  if (!m_agents_not_having_job.contains(new Integer(sender_id)))
                                                  {
						  	m_agents_not_having_job.add(new Integer(sender_id));
                                                        //if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Agents not having job increased 4 ");
                                                  }
						}	
					  }//end of own platoon control
					  	break;
					}
					
					case MSG_CLEAR:
					{
						full_message[MSG_FORMAT_HEAR_SENDER_ID]=0;
						if (notHeardBefore(full_message) && !m_cleared_roads.contains(new Integer(heard.subject))  )
						{
							if (COMM_LOGGING) m_msgParser.writeMyFile(m_filename,"Clear mesaji controllera geldi." + heard.subject);
							m_world_model.updateWorld(heard.subject,WORLD_MODEL_ROAD_INDEX,MAX_SEVERE_ROAD-1);
							
							
							//If we are not a police officer dispatcher we tell the news
							//otherwise we will assign this to one of our agents via the regular procedure
                                                        //messages received from other dispatchers not relayed
							if (m_agent_index!=WORLD_MODEL_POLICE_INDEX)
							{
                                                                if ( !(m_world_model.memberOf(WORLD_MODEL_CONTROLLER_INDEX,sender_id)) && !m_unreported_roads.contains(new Integer(heard.subject)))
									       m_unreported_roads.add(new Integer(heard.subject));
								
							}
						}
					  break;
					}
                                        
                                        //Polices send this message to their dispatcher
                                        //Police dispatcher sends this message to other polices
                                        //If quotas permit this messages is also sent to others
					case MSG_ROAD_CLEARED:
						{
							full_message[MSG_FORMAT_HEAR_SENDER_ID]=0;
							if (notHeardBefore(full_message))
							{
                                                                m_cleared_roads.add(new Integer(heard.subject));
								//System.out.println("Center received cleared msg "  + heard.subject);
								m_world_model.updateWorld(heard.subject,WORLD_MODEL_ROAD_INDEX,MIN_SEVERE_ROAD);
							
                                                                if (!m_unreported_clear.contains(new Integer(heard.subject)))
								        m_unreported_clear.add(new Integer(heard.subject));
							
							}
						}
					break;
					
					case MSG_HELPCIVPENDINGPOS:
					{
						if (notHeardBefore(full_message))
						{
							if (AMB_LOGGING) m_msgParser.writeMyFile(m_filename,"HELPCIVPENDINGPOS controllera geldi." + heard.subject);
							m_world_model.updateWorld(heard.subject,WORLD_MODEL_CIVILIAN_INDEX,HELP_REQUESTING_CIVILIAN);				
							//If we are not an ambulance dispatcher we tell the news
							//otherwise we will assign this to one of our agents
							if (!(m_world_model.memberOf(WORLD_MODEL_CONTROLLER_INDEX,sender_id)) && m_agent_index!=WORLD_MODEL_AMBULANCE_INDEX)
							{
								if (withinSayLimits())
								{
									if (AMB_LOGGING) m_msgParser.writeMyFile(m_filename,"HELPCIVPENDINGPOS controllerdan pas edildi." + heard.subject + " = " + sender_id );
									m_io.sendAK_TELL(m_id, MSG_HELPCIVPENDINGPOS, heard.subject);   
									increaseSaidNum();
									addHeardMessage(full_message);
								}
								else 
								{
                                                                        if (!m_unreported_civid.contains(new Integer(heard.subject)))
								        	m_unreported_civid.add(new Integer(heard.subject));
								}
							}	
							else
							{
								if (AMB_LOGGING) m_msgParser.writeMyFile(m_filename,"Civilian id pending position eklendi" +  heard.subject);
								//Adding the id of the civilian to update its position later
								m_civilian_updates.put(new Integer(sender_id), new Integer(heard.subject));
							}
						}	
						break;
					
					
					}
					case MSG_HELPCIVPOS:
					{
						if (AMB_LOGGING) m_msgParser.writeMyFile(m_filename,"Help civilian pos geldi.1 " + heard.subject + "-" +sender_id);
						//There may be more than one person in same position, therefore a sender may send civpos with same position several times
                                                //Therefore we do not use notHeardBefore function here...
						//if (notHeardBefore(full_message))
						//{
						
							if (m_agent_index!=WORLD_MODEL_AMBULANCE_INDEX)
							{
								if (!(m_world_model.memberOf(WORLD_MODEL_CONTROLLER_INDEX,sender_id)) && withinSayLimits())
								{
									//System.out.println("HELPCIVPOS controllerdan pas edildi." + heard.subject + " = " + sender_id );
									m_io.sendAK_TELL(m_id, MSG_HELPCIVPOS, heard.subject);   
									increaseSaidNum();
									addHeardMessage(full_message);
								}
							
							}
							else
							{
								if (AMB_LOGGING) m_msgParser.writeMyFile(m_filename,"Help civilian pos geldi.2" + heard.subject + "-" +sender_id);
								if (m_civilian_updates.containsKey(new Integer(sender_id)))
								{
									if (AMB_LOGGING) m_msgParser.writeMyFile(m_filename,"Bu position update ise yaradi" );
									Integer civ_id=(Integer)m_civilian_updates.remove(new Integer(sender_id));
									MovingObject the_civilian=(MovingObject)m_world_model.the_world[WORLD_MODEL_CIVILIAN_INDEX].get(civ_id);
									the_civilian.m_position=heard.subject;
									
								}
								//This is for other ambulances, if they want to go to the site they can
								if (notHeardBefore(full_message))
								{
									if (withinSayLimits())
									{
										m_io.sendAK_TELL(m_id, MSG_HELPCIVPOS, heard.subject);   
										increaseSaidNum();
										addHeardMessage(full_message);
									}
								}	
							}
						//}	
						break;
					}
					
					case MSG_POSITION:
						MovingObject my_agent;
						my_agent=(MovingObject)m_world_model.the_world[m_agent_index].get(new Integer(sender_id));
						my_agent.m_position=heard.subject;
						
						if (COMM_LOGGING) m_msgParser.writeMyFile(m_filename,"set the position of " +sender_id+ " to " + heard.subject);
						break;
                                                
                                        case MSG_FIERY_BUILDING:
                                                {
                                                        full_message[MSG_FORMAT_HEAR_SENDER_ID]=0;
                                                        if (notHeardBefore(full_message))
						        {
                                                                reported_building =(Building) m_world_model.the_world[WORLD_MODEL_BUILDING_INDEX].get(new Integer(heard.subject));
                                                                if (reported_building.m_fire_reported == 0)
                                                                {
                                                                        if (reported_building.m_fieryness ==0) reported_building.m_fieryness = 2;
                                                                        m_world_model.buildings_tobe_reported.add(reported_building);
                                                                }
                                                        }
                                                }        
                                                
					default:
						break;
				}//end of switch for heard message types
			}//end of received msg count control
		  }//end of sender id control
 		}//end of msg_type if(is it hear or send)
	}

	void assignMostUrgentJobToClosest(int numOfAgents)
	{
		SimObject maxseverityObject=null;
		MovingObject agentObject=null;
		int saveable_targets=m_num_saveable_targets;
		TargetDef max_obj_agent_assignment=null;
		
		
		boolean assignmentsComplete=false; //true when numOfAgents are assigned to a target
		int i;
			
		m_action_history[m_current_time].state=m_current_state;
		m_action_history[m_current_time].action=numOfAgents+URGENT_BASE-1;  //INVERSE OF THE CONVERSION MADE WHEN CALLING

		//m_msgParser.writeMyFile(m_filename,"Assigning urgent jobs to closest: " + numOfAgents + "each");
		
                //Looping for targets
		while (saveable_targets>0 && m_available_agents>=numOfAgents)
		{
			//if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"Urgent agent size:" + m_available_agents + " agents to assign:" + numOfAgents);
			maxseverityObject=null;
			agentObject=null;

                        //This returns the most urgent job - min distance agent pair
                        //If more than one urgent job, pair with min distance returned
			max_obj_agent_assignment = m_world_model.findMaxSeveritySet(m_target_index,m_agent_index, m_current_time);
			
			if (max_obj_agent_assignment.target == null) 
			{
				//if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"There is no job for the agents:most urgent.");
				break;
			}
			
			if (max_obj_agent_assignment.agent == null) 
			{
				//if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"There is no suitable agent:most urgent");
				break;
			}
			
			maxseverityObject=max_obj_agent_assignment.target;
			agentObject=(MovingObject)max_obj_agent_assignment.agent;
			HandleCenterJobAssignment(maxseverityObject, agentObject);
			saveable_targets--;
                        
                        //Assignments of the other agents (if more than one agent is being assigned to a target)
                      
                        for(i=1;i<numOfAgents;i++)
	                {
        	               agentObject = (MovingObject)m_world_model.findClosestAgent(m_agent_index,maxseverityObject);
	       		
	               	       if (agentObject==null) 
       		               {
        		              //if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"There is no more agent to assign to:most urgent.");
	               	       }
		               if (agentObject==null) 
        		       {
	               		      assignmentsComplete=true;
		              	      break;
		               }   
			
			       HandleCenterJobAssignment(maxseverityObject, agentObject);
        		}//End of assigning more than one agent	
                        
                        m_world_model.targets_tobe_saved.remove(maxseverityObject);
                        //m_msgParser.writeMyFile(m_filename,"Removed " + maxseverityObject.m_id);
                        //m_msgParser.writeMyFile(m_filename,"Still contains " + m_world_model.targets_tobe_saved.contains(maxseverityObject));
	                if (assignmentsComplete) break;       //If no agent or no target left, we shall return
                                            
		}//End of target search loop
	}//end of assignurgentjobtoclosest
	
	
	void assignLightestJobToClosest(int numOfAgents)
	{
		SimObject minseverityObject=null;
		MovingObject agentObject=null;
		int saveable_targets=m_num_saveable_targets;
		TargetDef min_obj_agent_assignment=null;
		
		
		boolean assignmentsComplete=false; //true when numOfAgents are assigned to a target
		int i;
			
		m_action_history[m_current_time].state=m_current_state;
		m_action_history[m_current_time].action=numOfAgents+LIGHTEST_BASE-1;


		//m_msgParser.writeMyFile(m_filename,"Assigning lightest jobs to closest: " + numOfAgents + "each");

                //Looping for targets		
		while (saveable_targets>0 && m_available_agents>=numOfAgents)
		{
                        //if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"Lightest agent size:" + m_available_agents + " agents to assign:" + numOfAgents);			
			minseverityObject=null;
			agentObject=null;

			min_obj_agent_assignment = m_world_model.findMinSeveritySet(m_target_index,m_agent_index, m_current_time);
			
			if (min_obj_agent_assignment.target== null) 
			{
				m_msgParser.writeMyFile(m_filename,"There is no job for the agents:lightest." + m_id);
				//if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"There is no job for the agents:lightest.");
				break;
			}
			
			if (min_obj_agent_assignment.agent == null) 
			{
                                m_msgParser.writeMyFile(m_filename,"There is no suitable agent" + m_id);
				//if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"There is no suitable agent:loghtest");
				break;
			}
			
			//System.out.println("Everything ok making first assignment" + m_id);
			minseverityObject=min_obj_agent_assignment.target;
			agentObject=(MovingObject)min_obj_agent_assignment.agent;
			HandleCenterJobAssignment(minseverityObject, agentObject);
			saveable_targets--;
                        
                        //Looping the agents
			for(i=1;i<numOfAgents;i++)
			{
		              agentObject = (MovingObject)m_world_model.findClosestAgent(m_agent_index,minseverityObject);
			
		              if (agentObject==null) 
		              {
		              	       m_msgParser.writeMyFile(m_filename,"There is no agent to assign to:most urgent.");
		              }
		              if (agentObject==null) 
	               	      {
		              	       assignmentsComplete=true;
        		               break;
	               	      }
		             
		              HandleCenterJobAssignment(minseverityObject, agentObject);
		         }
                         m_world_model.targets_tobe_saved.remove(minseverityObject);
                        // m_msgParser.writeMyFile(m_filename,"Removed " + minseverityObject.m_id);
                         //m_msgParser.writeMyFile(m_filename,"Still contains " + m_world_model.targets_tobe_saved.contains(minseverityObject));
                         
                         if (assignmentsComplete) break;
                        //if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"Remaining agents:" + m_agents_not_having_job.size() + " remaining targets:" + saveable_targets + "can we talk? " + withinSayLimits() );			   
                     
		}//End of target search loop
	}//end of assignlightestjobtoclosest
	
	
	final void HandleCenterJobAssignment(SimObject target, MovingObject agent)
	{
				assignments_done=true;
				target.m_assignedTo++;	//Count how many agents are assigned to this job
				agent.m_assignedTo = target.get_id();
		
				m_agents_requesting_job.remove(new Integer(agent.get_id()));
                                m_agents_not_having_job.remove(new Integer(agent.get_id()));
                                m_available_agents--;
                                //if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Agents not having job decreased 1 ");
                                
				//m_msgParser.writeMyFile(m_filename,"Assigned agent:" + agent.get_id() + " to job " +target.get_id());
				m_action_history[m_current_time].agent_job_pairs.put(new Integer(agent.get_id()), new Integer(target.get_id()));
				
				if (target instanceof MovingObject)
				{
                                        if (withinSayLimits())
                                        {
        				    m_io.sendAK_TELL(m_id, agent.m_execute_message, target.get_id(), agent.get_id());
			             	    increaseSaidNum();
                                        }
                                        else
                                        {
                                            m_pending_assignments.add(new AssignmentItem(agent.m_execute_message, target.get_id(), agent.get_id()));
                                        }
                                        if (withinSayLimits())
                                        {
                                            m_io.sendAK_TELL(m_id, MSG_EXPOS , ((MovingObject)target).get_position(), agent.get_id());
                                            increaseSaidNum();
                                        }
                                        else
                                        {
                                            m_pending_assignments.add(new AssignmentItem(MSG_EXPOS, ((MovingObject)target).get_position(), agent.get_id()));
                                        }
				}
				else
				{
                                        if (withinSayLimits())
                                        {
					   m_io.sendAK_TELL(m_id, MSG_EXECUTE, target.get_id(), agent.get_id());
					   if (COMM_LOGGING) m_msgParser.writeMyFile(m_filename,"assignmenti yolladik.2");
					   increaseSaidNum();
                                        }
                                        else
                                        {
                                            m_pending_assignments.add(new AssignmentItem(MSG_EXECUTE, target.get_id(), agent.get_id()));
                                        }
				}
	
	}

        
	
	void assignEachJobToClosest(int numOfAgents)
	{
		SimObject theObject=null;
		MovingObject agentObject=null;
		int saveable_targets=m_num_saveable_targets;
		TargetDef obj_agent_assignment=null;
		
		
		boolean assignmentsComplete=false; //true when numOfAgents are assigned to a target
		int i;
			
		m_action_history[m_current_time].state=m_current_state;
		m_action_history[m_current_time].action=numOfAgents+CLOSEST_BASE-1;


		//System.out.println("Function called: " + m_action_history[m_current_time].action + "time " + m_current_time);
		//m_msgParser.writeMyFile(m_filename,"Assigning jobs to closest: " + numOfAgents + "each");

                //Looping for targets		
		while (saveable_targets>0 && m_available_agents>=numOfAgents)
		{
                        //if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"Lightest agent size:" + m_available_agents + " agents to assign:" + numOfAgents);			
			theObject=null;
			agentObject=null;

			obj_agent_assignment = m_world_model.findClosestSet(m_target_index,m_agent_index);
			
			if (obj_agent_assignment.target== null) 
			{
				m_msgParser.writeMyFile(m_filename,"There is no job for the agents: closest" + m_id);
				//if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"There is no job for the agents:lightest.");
				break;
			}
			
			if (obj_agent_assignment.agent == null) 
			{
                                m_msgParser.writeMyFile(m_filename,"There is no suitable agent : closest" + m_id);
				//if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"There is no suitable agent:loghtest");
				break;
			}
			
			//System.out.println("Everything ok making first assignment" + m_id);
			theObject=obj_agent_assignment.target;
			agentObject=(MovingObject)obj_agent_assignment.agent;
			HandleCenterJobAssignment(theObject, agentObject);
			saveable_targets--;
                        
                        //Looping the agents
			for(i=1;i<numOfAgents;i++)
			{
		              agentObject = (MovingObject)m_world_model.findClosestAgent(m_agent_index,theObject);
			
		              if (agentObject==null) 
		              {
		              	       m_msgParser.writeMyFile(m_filename,"There is no agent to assign to: closest.");
		              }
		              if (agentObject==null) 
	               	      {
		              	       assignmentsComplete=true;
        		               break;
	               	      }
		             
		              HandleCenterJobAssignment(theObject, agentObject);
		         }
                         m_world_model.targets_tobe_saved.remove(theObject);
                         //m_msgParser.writeMyFile(m_filename,"Removed " + theObject.m_id);
                         //m_msgParser.writeMyFile(m_filename,"Still contains " + m_world_model.targets_tobe_saved.contains(theObject));
                         if (assignmentsComplete) break;
                        //if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"Remaining agents:" + m_agents_not_having_job.size() + " remaining targets:" + saveable_targets + "can we talk? " + withinSayLimits() );			   
                     
		}//End of target search loop
	}//end of assignlightestjobtoclosest
        
        
        
//10.01.2003 // Starts assignment by choosing agents first -- old version        
/*
	void assignEachAgentToClosest(int numOfAgents)
	{
		int i,j;
		SimObject closestObject=null;	
		MovingObject agentObject=null;	
		Integer tempIndex;				//For getting agents requesting job
		int saveable_targets=m_num_saveable_targets;
		int agents_requesting_job_size;
		int target_general_type; 

		m_action_history[m_current_time].state=m_current_state;
		m_action_history[m_current_time].action=numOfAgents+CLOSEST_BASE-1;

		agents_requesting_job_size=m_agents_requesting_job.size();
*/                
                /*
		//PART A:First assign job to those requesting
		for (i=0;i<agents_requesting_job_size && (( m_agent_index!=WORLD_MODEL_CIVILIAN_INDEX && withinSayLimits())|| ( m_agent_index==WORLD_MODEL_CIVILIAN_INDEX && withinDoubleSayLimits())) ;i++)
		{
			closestObject=null;
			
			if (C_LOGGING) m_msgParser.writeMyFile(m_filename,"Assigning agents that requested job to closest");
			tempIndex=(Integer)m_agents_requesting_job.get(0);
			agentObject=(MovingObject)m_world_model.getObjectbyId(tempIndex.intValue(),m_agent_index);
			
			if (agentObject.m_assignedTo<=0)
			{
				//find the closest target that has not yet been assigned to numOfAgents number of agents
			        if (m_agent_index == WORLD_MODEL_FIREFIGHTER_INDEX)
                                {
                                        closestObject = m_world_model.FindClosestBurningBuilding(agentObject,numOfAgents,null);   
                                }
                                else
                                {
                                        closestObject = m_world_model.findClosest(m_world_model.the_world[m_target_index],agentObject,true,numOfAgents,null);
                                }
                                
				if (closestObject==null) 
				{
					if (C_LOGGING) m_msgParser.writeMyFile(m_filename,"No job for agent");
				}
				if (closestObject==null) 
				{
					break;		//If there is no closest, there is nothing
				}
			
				closestObject.m_assignedTo ++;
				agentObject.m_assignedTo = closestObject.m_id;
                                //Since this agent is assigned a job, we are removing it from the list
                                m_agents_requesting_job.remove(tempIndex);
				if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Assigned agent:" + tempIndex + " to building " +closestObject.m_id);
                                m_agents_not_having_job.remove(tempIndex);
                                if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Agents not having job decreased 2 ");
			        assignments_done=true;
				m_action_history[m_current_time].agent_job_pairs.put(new Integer(agentObject.m_id), new Integer(closestObject.m_id));	
				if (closestObject instanceof MovingObject)
				{
					m_io.sendAK_TELL(m_id, agentObject.m_execute_message, closestObject.get_id());
					m_io.sendAK_TELL(m_id, MSG_EXPOS + (agentObject.m_execute_message-MSG_AMBULANCE_EXECUTE), ((MovingObject)closestObject).get_position());
					if (AMB_LOGGING) m_msgParser.writeMyFile(m_filename,"Expos yolladik, each to closest, requesting job");
					increaseSaidNum();
					increaseSaidNum();
				}
				else
				{
					m_io.sendAK_TELL(m_id,agentObject.m_execute_message, closestObject.m_id);
					if (COMM_LOGGING) m_msgParser.writeMyFile(m_filename,"assignmenti yolladik.1");
					increaseSaidNum();
				}
			}//end of the agent is assigned check
			else
			{
                                //For preventing this agent from being chosen in the next loop of the for
				m_agents_requesting_job.remove(tempIndex);
			}
		}//End of for loop
		*/
/*                
		//PART B:Then assign job to rest
                int loop_count = 0 ;
                int running_count = 0;
                
                if (m_available_agents <= m_num_saveable_targets)
                        loop_count = m_available_agents;
                else
                        loop_count = m_available_agents - (m_available_agents % m_num_saveable_targets);

               //if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"numOfAgents:" + numOfAgents + "available agents" + 
               +  " initial_target_count:" + m_num_saveable_targets + "loop count" + loop_count);         
                        
		while (running_count < loop_count)
		{
			closestObject=null;
			agentObject=null;

			//Try to find an unassigned agent
			Iterator it=m_world_model.the_world[m_agent_index].keySet().iterator();
			while (it.hasNext())
			{
				tempIndex=(Integer)it.next();
				agentObject=(MovingObject)m_world_model.the_world[m_agent_index].get(tempIndex);
				if (agentObject !=null)
				{
					if (agentObject.get_assignedTo()<=0 && agentObject.get_position()>0) 
					{
						if (C_LOGGING) m_msgParser.writeMyFile(m_filename,"Assignment 1 agent id " + agentObject.m_id + "currently assigned to " +agentObject.get_assignedTo());
						break;
					}
					else
					{
						if (C_LOGGING) m_msgParser.writeMyFile(m_filename,"Assignment 1 agent id " + agentObject.m_id + "currently assigned to " +agentObject.get_assignedTo() + "position" + agentObject.get_position() );

						agentObject=null;
					}
				}
			}//End of agent search while
			//Agent not found
			if (agentObject==null) 
			{
                                m_msgParser.writeMyFile(m_filename,"No agent to assign to : closest");
			}
			if (agentObject==null)
			{
				break;
			}	

			
                        //find the closest target that has not yet been assigned to numOfAgents number of agents
			if (m_agent_index == WORLD_MODEL_FIREFIGHTER_INDEX)
                        {
                                closestObject = m_world_model.FindClosestBurningBuilding(agentObject,numOfAgents,null);   
                        }
                        else
                        {
                                closestObject = closestObject = m_world_model.findClosestTarget(agentObject,numOfAgents, null);
                        }
                        
			if (closestObject==null) 
			{
				m_msgParser.writeMyFile(m_filename,"No job for the agent.: closest");
			}
			if (closestObject==null) 
			{
				break;		//If there is no closest, there is nothing
			}
                        
			running_count++;
                        HandleCenterJobAssignment(closestObject, agentObject);
		}//End of `rest of the agents` loop
	}//End of 'assign each to closest'
*/
        
        
	int find_state_action_time(int sender_id, int subject_id)
	{
		int i;
		int returnval=-1;
                Integer the_subject;
		
		//search starting from previous time backwards
		for (i=m_current_time-1;i>=0;i--)
		{
			if(m_action_history[i].agent_job_pairs.containsKey(new Integer(sender_id)))
			{ 
                                the_subject= (Integer) m_action_history[i].agent_job_pairs.get(new Integer(sender_id));
                                if (the_subject.intValue() == subject_id)
                                {
                                        //if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"The time of job assignment for " + sender_id + "for object " + subject_id  + " is " + i );
                                        returnval=i;
				        break;
                                }	
			}
		}	
		return returnval;	
	}
        
        
        /*
        //Sometimes the assignment message arrives late to the agent and it sends job request
        //It is not because that it has finished the job...
        //So we don@t use this code
        void ClearJobsAssignedTo( int sender_id)
        {
                int i;
		int returnval=-1;
                Integer the_subject;
		
		//search starting from previous time backwards
		for (i=m_current_time-1;i>=0;i--)
		{
			if(m_action_history[i].agent_job_pairs.containsKey(new Integer(sender_id)))
			{ 
                                the_subject= (Integer) m_action_history[i].agent_job_pairs.get(new Integer(sender_id));
                                m_world_model.clearAssignedToOf(the_subject.intValue(),m_target_index);
                                if (PRE_LOGGING)m_msgParser.writeMyFile(m_filename,"Clearing the assignment of " + the_subject.intValue() + " is since agent"  + sender_id  +  "requested job" );  
			}
		}	
        }
	*/
	
	final boolean withinHearLimits()
	{
		return (m_rcvd_message_count<m_max_rcv_msg);
	}
	
	final boolean withinSayLimits()
	{
		return (m_sent_message_count<m_max_send_msg);
	}
	
	final boolean withinDoubleSayLimits()
	{
		return (m_sent_message_count<m_max_send_msg-1);
	}
	
	
	final void increaseHeardNum()
	{
		m_rcvd_message_count++;
	}
	
	final void increaseSaidNum()
	{
		m_sent_message_count++;
	}
	
	final void resetHeardSaid()
	{
		m_rcvd_message_count=0;
		m_sent_message_count=0;	
	}
	
	final boolean notHeardBefore(int [] hear_message)
	{
		//return (!m_heard_messages.contains(hear_message));
                
                String str;
                int i;
                str = "";
                for (i=0; i< hear_message.length; i++)
                {
                        str = str + "" + hear_message [i];
                }
                
                if (!m_heard_messages.contains(str))
                {
                        return true;
                }
                else
                {
                        return false;
                }
	}
	
	final void addHeardMessage(int [] hear_message)
	{
                String str;
                int i;
                str = "";
                for (i=0; i< hear_message.length; i++)
                {
                        str = str + "" + hear_message [i];
                }
                
		m_heard_messages.add(str);
	}

	final int numOfSaveableTargets(byte m_target_index)
	{   
                return (int)m_world_model.targets_tobe_saved.size();
	}

        final int availableAgents()
        {
                int i;
                int available_count=0;
                Integer agentIndex;
                MovingObject theAgent;
                
                for (i= 0 ; i<m_agents_not_having_job.size(); i++)
                {
                        agentIndex = (Integer)m_agents_not_having_job.get(i);
                        theAgent = (MovingObject)m_world_model.the_world[m_agent_index].get(agentIndex);
                        if (theAgent.get_position()>0)
                        {
                                available_count++;
                                //if (PRE_LOGGING) m_msgParser.writeMyFile(m_filename,"Agent Available:" + theAgent.m_id);
                        }
                }
                
                return available_count;
        }
        
}




class ActionHistoryItem
{
	int state;
	int action;
	Hashtable agent_job_pairs;

	ActionHistoryItem()
	{
		state=-1;
		action=-1;
		agent_job_pairs=new Hashtable();
	}
}

class AssignmentItem
{
        int agent_msg;
        int target_id;
	int agent_id;

        AssignmentItem(int x_agent_msg, int x_target_id, int x_agent_id)
        {
                agent_msg = x_agent_msg;
                target_id = x_target_id;
	   	agent_id = x_agent_id;
        }


}


class FireFighterController extends ControllerThd
{

	FireFighterController(int agent_type, String inetaddr, int training_run_num)
	{
		super(agent_type,inetaddr, training_run_num);
		m_learner.set_q_filename("FFIC_Q.txt");
	}

	void setAgentSpecificConstants()
	{
		m_agent_index=WORLD_MODEL_FIREFIGHTER_INDEX;
		m_target_index=WORLD_MODEL_BUILDING_INDEX;
		m_target_ruined=BURNED_OUT_BUILDING;
		m_target_saved=EXTINGUISHED_BUILDING1;
		m_execute_base=MSG_FIREFIGHTER_EXECUTE;
	}
	
}

class AmbulanceController extends ControllerThd
{

	AmbulanceController(int agent_type, String inetaddr, int training_run_num)
	{
		super(agent_type,inetaddr, training_run_num);
		m_learner.set_q_filename("AMBC_Q.txt");
	}


	void setAgentSpecificConstants()
	{
		m_agent_index=WORLD_MODEL_AMBULANCE_INDEX;
		m_target_index=WORLD_MODEL_CIVILIAN_INDEX;
		m_target_ruined=MAX_SEVERE_CIVILIAN;
		m_target_saved=MIN_SEVERE_CIVILIAN;
		m_execute_base=MSG_AMBULANCE_EXECUTE;
	}
	
}

class PoliceController extends ControllerThd
{

	PoliceController(int agent_type, String inetaddr, int training_run_num)
	{
		super(agent_type,inetaddr, training_run_num);
		m_learner.set_q_filename("POLC_Q.txt");
	}

	void setAgentSpecificConstants()
	{
		m_agent_index=WORLD_MODEL_POLICE_INDEX;
		m_target_index=WORLD_MODEL_ROAD_INDEX;
		m_target_ruined=MAX_SEVERE_ROAD;
		m_target_saved=MIN_SEVERE_ROAD;
		m_execute_base=MSG_POLICE_EXECUTE;
	}
	
}

