class FireFighterTeam extends AgentThd
{
        int m_refuge_id;
        
	FireFighterTeam(int agent_type, String prefix, String inetaddr, int training_run_num)
	{
                
		super(agent_type,prefix,inetaddr, training_run_num);
                m_refuge_id=-1;
	}


	final void SetAgentSpecificConstants()
	{
		m_agent_index=WORLD_MODEL_FIREFIGHTER_INDEX;
		m_target_index=WORLD_MODEL_BUILDING_INDEX;
		m_execute_base=MSG_FIREFIGHTER_EXECUTE;
		//m_timeout=DEF_FIREFIGHTER_TIME_OUT;
		m_positive_reward=FIREFIGHTER_REWARD;
	}

	final boolean ArrivedToTarget()
	{
                return m_world_model.withinExtDist((StaticObject)m_current_job.target_object,m_x,m_y);              
	}
	
	
	final byte targetRuined(Job this_job)
	{
		if (this_job.target_object==null)
		{
			if (FF_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction: Target object is null.");
			return JOB_STATUS_UNKNOWN;
		}
		if (m_world_model.burntDown(this_job.target_object))
		{
			if (FF_LOGGING) m_msgParser.writeMyFile(m_filename,"Target: " + this_job.target_id + "ruined by" + m_id); 
			return RUINED;
		}
		return NOT_RUINED;
	
	}
	
	final byte targetSaved()
	{
		if (m_current_job.target_object==null)
		{
			if (FF_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction: Target object is null.");
			return JOB_STATUS_UNKNOWN;
		}
	
		if (m_world_model.extinguished(m_current_job.target_object))
		{
			if (m_current_job.took_action )
			{
				return SAVED_BY_ME;
			}
			else
			{
				return SAVED_BY_OTHER;
			}
		}
		return NOT_SAVED_YET;
	}

	final void takeAction()
	{
	  if (!current_action_done)
	  {
	  
		//System.out.println("" + m_id + ": My water quantity is " +((FireFighter)m_myself).m_waterquantity);
		
                
                if (((FireFighter)m_myself).m_waterquantity==0  && !(m_world_model.atRefuge(m_myself)) )
                {
                      //go to refuge
   
   			//System.out.println("" + m_id + ": going to refuge");
                        if (m_refuge_id==-1)
			{
				SimObject m_refuge;
				m_refuge=m_world_model.findClosest(m_world_model.the_world[WORLD_MODEL_REFUGE_INDEX],we_are_at,false);
				m_refuge_id=m_refuge.get_id();
			}
			
			moveTo(m_refuge_id,false);
		
                        return;
                }
                
                if (((FireFighter)m_myself).m_waterquantity<MAX_TANK_CAPACITY  && (m_world_model.atRefuge(m_myself)))
                {
                   	//System.out.println("" + m_id + ": at refuge");
                        m_refuge_id=-1;
                        return;
                }
                
                
		//If the target is saved or ruined this is determined beforehand, this function only deals with the 'not arrived to target' and 'arrived to target but not finished the job' cases

		int direction;
		if (!ArrivedToTarget())
		{
			if (FF_LOGGING) m_msgParser.writeMyFile(m_filename,"Far from target.");
			moveTo(m_current_job.target_id,true); //We shall find path to a building, but remove the building itself from the target
		}

		else if (m_world_model.saveable(m_current_job.target_object))
		{
			if (FF_LOGGING) m_msgParser.writeMyFile(m_filename,"Close to target...sending extinguish");
			//It is ok not to send direction, so save resources
                        //direction=direction(m_x,m_y,((StaticObject)m_current_job.target_object).get_x(),((StaticObject)m_current_job.target_object).get_y());
			//System.out.println("Direction is: " + direction);
			m_io.sendAK_EXTINGUISH(m_id, m_current_job.target_id, 0 ,m_x,m_y, FIREFIGHTER_EXTINGUISHABLE_QUANTITY);
			//System.out.println("Firefighter " + m_id + " extinguishing building " +  m_current_job.target_id + "time " + m_current_time);
			current_action_done=true;
			m_current_job.took_action=true;
		}
		else
		{
			if (FF_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction: target found but not saveable ????");
			if (m_world_model.burntDown(m_current_job.target_object))
                                handleCenterReply(m_current_job, MSG_NEUTRAL_NEG);
                        else
                                handleCenterReply(m_current_job, MSG_NEUTRAL_POS);
			resetJobIndicators(m_current_job.target_id);
		}
		
	  }//current action done test
	}

        final void takeActionRandom()
	{
        }
        final void takeActionRandomArrived()
        {}
                
        final SimObject findMaxSeverity(int m_x, int m_y, int current_time, Job current_target)
        {
                 return m_world_model.findMaxSeverity_building(m_x, m_y, current_time, current_target);
        }
        
        
        final double getStatusOfJob(Job theJob)
        {
                return ((Building)theJob.target_object).get_fieryness();
        }
        
        final void setStatusOfJob(Job theJob)
        {
                theJob.initial_status=((Building)theJob.target_object).get_fieryness();
        }
        
        final double compareStatuswithOld(Job theJob)
        {
                        if (m_world_model.extinguished(theJob.target_object))
			{     
				handleCenterReply(theJob, MSG_NEUTRAL_POS);
				removeFromJobQueue(theJob);
				return QUEUE_REWARD;
			}
			else if (m_world_model.burntDown(theJob.target_object))
			{
				handleCenterReply(theJob, MSG_NEUTRAL_NEG);
				removeFromJobQueue(theJob);
				return -QUEUE_REWARD;
			}
			else if (theJob.initial_status<((Building)theJob.target_object).get_fieryness())
                        {      
				return -QUEUE_REWARD;
                        }
                        
                        return 0.0;
        }
        
        //When this function is called theJob is already known to be unsaveable
        final double compareStatuswithOldUnsaveable(Job theJob)
        {
                        if (m_world_model.extinguished(theJob.target_object))
			{
				handleCenterReply(theJob, MSG_NEUTRAL_POS);
				removeFromJobQueue(theJob);
				return ACCUMULATED_REWARD;
			}
			else //if ! burntdown condition already satisfied (if not saveable and is not ext then burntdown)
			{	
				handleCenterReply(theJob, MSG_NEUTRAL_NEG);
				removeFromJobQueue(theJob);
				return -ACCUMULATED_REWARD;
			}
                       
        }
}
