import java.io.*;
import java.util.*;

class LearningComponent implements Definitions
{
	double [] m_reward_function;            //Reward function is a step function
	double [][] m_q_values;			//Q-values for multi-action possibilities
	double [][] m_p_values;			//Q-values for preemption

	int [][] m_q_trace;	
	int [][] m_p_trace;	

        int numofstates;
	String m_log_filename;
	String m_q_filename;
	String m_p_filename;
	String m_Qvisit_filename;
	String m_Pvisit_filename;
	Random randomgen;
	
	int m_prev_state;
        int m_q_prev_state;
        byte m_agent_index;
	byte [] m_prev_order;
        byte m_prev_action;
        int i,j;
        MessageParser m_msgParser;
        
	LearningComponent()
	{
		m_prev_state=-1;
		m_prev_order=new byte[def_action_source_num];
		m_prev_order[0]=1;
		m_prev_order[1]=1;
		m_prev_order[2]=1;
		
		numofstates=DEF_NUM_MY_LEVELS;
		for(i=1;i<def_environment_types;i++)
			numofstates*=DEF_NUM_OTHER_LEVELS;
	
		m_reward_function=new double[numofstates];
		m_q_values=new double[numofstates][def_agent_action_num];
		m_q_trace=new int[numofstates][def_agent_action_num];
		
		m_p_values=new double[numofstates][def_action_source_num];
		m_p_trace=new int[numofstates][def_action_source_num];
                
                m_msgParser=new MessageParser();
		
		randomgen= new Random();
		randomgen.setSeed(System.currentTimeMillis());
                
                double max_reward[] = {16.0,12.0,12.0,8.0};
                double decrement[] = {1.0,0.75,0.75,0.5};
                       
                //CHANGE FOR NEWEST        
                for (j=0;j<4;j++)
		{
                        for (i=0;i<16;i++)
                        {
			     m_reward_function[16*j+i]=max_reward[j]-(i*decrement[j]);
			     //System.out.println("Reward " + (int)(16*j+i) + ": " + m_reward_function[16*j+i]);
                        }
		}
		
		m_log_filename="Dummy.txt";			//In order for javac to compile
		m_q_filename="Dummy1.txt";
		m_p_filename="Dummy2.txt";
		m_Qvisit_filename="Dummy1.txt";
		m_Pvisit_filename="Dummy2.txt";
	}
	
	final void set_log_filename(String filename,byte agent_index)
	{
		m_log_filename=filename;
                m_agent_index=agent_index;
	}
	
	final void set_q_filename(String filename)
	{
		m_q_filename=filename;
	}
	
	final void set_p_filename(String filename)
	{
		m_p_filename=filename;
	}
	
	final void set_Qvisit_filename(String filename)
	{
		m_Qvisit_filename=filename;
	}
	final void set_Pvisit_filename(String filename)
	{
		m_Pvisit_filename=filename;
	}
	
	final void updatePvalueIntermediate(int state_to_update, int source_to_update,double reward, int alternative_type)
	{
                //GREEDY
                /*
                reward/=100;
                
		if (alternative_type==ALT_NO_ALT)
			return;
		
                if (source_to_update == ACTION_SOURCE_CENTER_ENV)
                {
		      m_p_values[state_to_update][ACTION_SOURCE_CENTER]+= def_learning_rate *reward;
                      m_p_trace[state_to_update][ACTION_SOURCE_CENTER]+= 1;
                      m_p_values[state_to_update][ACTION_SOURCE_ENVIRONMENT]+= def_learning_rate *reward;
                      m_p_trace[state_to_update][ACTION_SOURCE_ENVIRONMENT]+= 1;
		}
                else if (source_to_update == ACTION_SOURCE_CENTER_OWN)
                {
		      m_p_values[state_to_update][ACTION_SOURCE_CENTER]+= def_learning_rate *reward;
                      m_p_trace[state_to_update][ACTION_SOURCE_CENTER]+= 1;
                      m_p_values[state_to_update][ACTION_SOURCE_OWN]+= def_learning_rate *reward;
                      m_p_trace[state_to_update][ACTION_SOURCE_OWN]+= 1;
		}
                else
                {
                      m_p_values[state_to_update][source_to_update]+= def_learning_rate *reward;
                      m_p_trace[state_to_update][source_to_update]+= 1;
                }
                */
	}
	
	final void updatePvalues(int state_to_update, int source_to_update, int current_state, double m_prev_action_result, int current_time, int alternative_type, double reward_multiplier)
	{
                //GREEDY
                /*
	
		if (alternative_type==ALT_NO_ALT)
			return;
         */               
	/*		
		double max_p_of_current_state=MY_MINDOUBLE;
	
		for (i=0;i<def_action_source_num;i++)
		{
			if (m_p_values[current_state][i] > max_p_of_current_state)
                        {
				max_p_of_current_state=m_p_values[current_state][i];
                        }
                        //System.out.println("current val" + m_p_values[current_state][i]);
		}
                
///////////////////////////////////////////////////////////////////////////////////////////////////////////////		
		
                
                if (source_to_update == ACTION_SOURCE_CENTER_ENV)
                {
                      m_p_values[state_to_update][ACTION_SOURCE_CENTER]+= def_learning_rate * (m_reward_function[state_to_update]+m_prev_action_result + max_p_of_current_state - m_p_values[state_to_update][ACTION_SOURCE_CENTER]);
		      m_p_trace[state_to_update][ACTION_SOURCE_CENTER]+= 1;
                      m_p_values[state_to_update][ACTION_SOURCE_ENVIRONMENT]+= def_learning_rate * (m_reward_function[state_to_update]+m_prev_action_result + max_p_of_current_state - m_p_values[state_to_update][ACTION_SOURCE_ENVIRONMENT]);
		      m_p_trace[state_to_update][ACTION_SOURCE_ENVIRONMENT]+= 1;
                }
                else if (source_to_update == ACTION_SOURCE_CENTER_OWN)
                {
                      m_p_values[state_to_update][ACTION_SOURCE_CENTER]+= def_learning_rate * (m_reward_function[state_to_update]+m_prev_action_result + max_p_of_current_state - m_p_values[state_to_update][ACTION_SOURCE_CENTER]);
		      m_p_trace[state_to_update][ACTION_SOURCE_CENTER]+= 1;
                      m_p_values[state_to_update][ACTION_SOURCE_OWN]+= def_learning_rate * (m_reward_function[state_to_update]+m_prev_action_result + max_p_of_current_state - m_p_values[state_to_update][ACTION_SOURCE_OWN]);
		      m_p_trace[state_to_update][ACTION_SOURCE_OWN]+= 1;
                }
                else
                {       
                      //System.out.println("P:state_to_update" + state_to_update + "source_to_update" + source_to_update + "current_state " + current_state + " state to update " + state_to_update);
                      //System.out.println ("P:(" + m_reward_function [ state_to_update ] + "+ " + m_prev_action_result + " + " +  max_p_of_current_state + " - " + m_p_values [state_to_update][source_to_update] + ")");
		      m_p_values[state_to_update][source_to_update]+= def_learning_rate * (m_reward_function[state_to_update]+m_prev_action_result + max_p_of_current_state - m_p_values[state_to_update][source_to_update]);
		      m_p_trace[state_to_update][source_to_update]+= 1;
                      //System.out.println ("Result of this equation:" + m_p_values[state_to_update][source_to_update]);
                      
                }
	
        */
        //GREEDY
        /*
                double reward = m_prev_action_result/100;

	       if (source_to_update == ACTION_SOURCE_CENTER_ENV)
                {
                      m_p_values[state_to_update][ACTION_SOURCE_CENTER]+= def_learning_rate * (reward + m_reward_function[current_state]*reward_multiplier);
		      m_p_trace[state_to_update][ACTION_SOURCE_CENTER]+= 1;
                      m_p_values[state_to_update][ACTION_SOURCE_ENVIRONMENT]+= def_learning_rate * (reward + m_reward_function[current_state]*reward_multiplier);
		      m_p_trace[state_to_update][ACTION_SOURCE_ENVIRONMENT]+= 1;
                }
                else if (source_to_update == ACTION_SOURCE_CENTER_OWN)
                {
                      m_p_values[state_to_update][ACTION_SOURCE_CENTER]+= def_learning_rate * (reward + m_reward_function[current_state]*reward_multiplier);
		      m_p_trace[state_to_update][ACTION_SOURCE_CENTER]+= 1;
                      m_p_values[state_to_update][ACTION_SOURCE_OWN]+= def_learning_rate * (reward + m_reward_function[current_state]*reward_multiplier);
		      m_p_trace[state_to_update][ACTION_SOURCE_OWN]+= 1;
                }
                else
                {   
		      m_p_values[state_to_update][source_to_update]+= def_learning_rate * (reward + m_reward_function[current_state]*reward_multiplier);
		      m_p_trace[state_to_update][source_to_update]+= 1;
                      
                }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////
		*/
	}

	final void updateQvalues(int previous_state, int previous_action, int current_state, double m_prev_action_result, int current_time)
	{
                /*
		double max_q_of_current_state=MY_MINDOUBLE;
	
		for (i=0;i<def_agent_action_num;i++)
		{
			if (m_q_values[current_state][i] > max_q_of_current_state)
				max_q_of_current_state=m_q_values[current_state][i];
		}

		m_q_values[previous_state][previous_action]+= def_learning_rate * (m_reward_function[previous_state]+m_prev_action_result + max_q_of_current_state - m_q_values[previous_state][previous_action]);
                */
                //GREEDY
                /*
                double reward = m_prev_action_result/100;
                
                m_q_values[previous_state][previous_action]+= def_learning_rate * (reward + m_reward_function[current_state]);
                
                //System.out.println("Q:previous_state" + previous_state + "previous_action" + previous_action  + "current_state " + current_state);
                //System.out.println ("Q:(" + m_reward_function[previous_state] + "+" + m_prev_action_result + "+" +  max_q_of_current_state +" - " + m_q_values[previous_state][previous_action]+ ")");
                
		m_q_trace[previous_state][previous_action]+=1;	
                */
	}
	
	
	
	final void updateQvaluesIntermediate(int previous_state, int previous_action, int intermediate_result, int current_time)
	{
                //GREEDY
                /*
                double reward;
                reward =intermediate_result;
                reward/=100;
                
		m_q_values[previous_state][previous_action]+= def_learning_rate * reward;
		m_q_trace[previous_state][previous_action]+=1;
                */
	}

	final byte decideOnAction(int current_state)
	{
		
		double max_q_of_current_state=MY_MINDOUBLE;
		byte max_q_action=0;				
		byte random_action=0;
                
                if (current_state==m_q_prev_state)
		{
			//m_msgParser.writeMyFile(m_log_filename, m_prev_order[0] + " " + m_prev_order[1] + " " + m_prev_order[2] + " again" );
			return m_prev_action;
		}	

		m_q_prev_state=current_state;
		
		for (i=0;i<def_agent_action_num;i++)
		{
			if (m_q_values[current_state][i] > max_q_of_current_state)
			{	
				max_q_of_current_state=m_q_values[current_state][i];
				max_q_action=(byte)i;
			}
		}		


		if (def_q_explorer)
		{	
			if (randomgen.nextFloat() < def_q_accept_probability)
			{
				do{
					//random_action=(int)Math.round(randomgen.nextFloat()*(double)(def_agent_action_num-1));
                                        //In order to give each choice a uniform chance, round function is changed to floor
                                        random_action=(byte)Math.floor(randomgen.nextFloat()*(double)(def_agent_action_num));
                                        if (random_action == def_agent_action_num) random_action--;
				}while(random_action==max_q_action);
                                m_prev_action = random_action;
				return random_action;
			}
		}
                m_prev_action = max_q_action;
		return max_q_action;
		
	}
	
	
	final byte[] getPreemptionOrder(int current_state, int id)
	{					
		double [] values_to_sort;	//Actual p-values to sort
		byte [] sorted_order={ACTION_SOURCE_OWN, ACTION_SOURCE_CENTER, ACTION_SOURCE_ENVIRONMENT};  //After being sorted this array contains the one with the least p-value in 0th element, most p-value in 2nd element
		
		byte [] return_order; //This array contains the priority of center in 0th element, priority of environment in 1st element, priority of own in 2nd element
		return_order=new byte [def_action_source_num];
		
			
		if (current_state==m_prev_state)
		{
			//m_msgParser.writeMyFile(m_log_filename, m_prev_order[0] + " " + m_prev_order[1] + " " + m_prev_order[2] + " again" );
			return m_prev_order;
		}	

		m_prev_state=current_state;
		
	
		/*ACTUAL ORDERIN 0 1 2 SEKLINDE IFADESI*/
		/*Sorted order contains center<env<own or the like after this operation*/
		values_to_sort=(double [])m_p_values[current_state].clone();
                //m_msgParser.writeMyFile(m_log_filename, "Priorities of own-dsp-env" + values_to_sort[0] + " " + values_to_sort[1] + " " + values_to_sort[2] );
		
                if (values_to_sort[0]>values_to_sort[1])
		{
			SwitchVal(0,1,values_to_sort);       //values_to_sort are the actual p-values like 3.45446 ...
			SwitchVal(0,1,sorted_order);         //sorted_order is the ordering of sources like env, own ...
		}
		
		if (values_to_sort[1]>values_to_sort[2])
		{
			SwitchVal(1,2,values_to_sort);
			SwitchVal(1,2,sorted_order);
		}
		
		if (values_to_sort[0]>values_to_sort[1])
		{
			SwitchVal(0,1,sorted_order);
		}
			
                //m_msgParser.writeMyFile(m_log_filename, "Sources in order of prio" + sorted_order[0] + " " + sorted_order[1] + " " + sorted_order[2] );
                
		/*ACTUAL ORDER YERINE SUB-OPTIMAL ORDER BUL*/
		//IF WE ARE EXPLORER
		if (def_p_explorer)
		{	//IF WE ARE GOING SUB_OPTIMAL
			if (randomgen.nextFloat() < def_p_accept_probability)
			{
				if (Math.round(randomgen.nextFloat())<0.5)
					//Switch the two lower ones
					SwitchVal(0,1,sorted_order);
			
				if (Math.round(randomgen.nextFloat())<0.5)
					//Switch the max with the least
					SwitchVal(0,2,sorted_order);
				else
					//Switch the max with the middle
					SwitchVal(1,2,sorted_order);
				
			}
		}
		
                //m_msgParser.writeMyFile(m_log_filename, "Sources mixed order      " + sorted_order[0] + " " + sorted_order[1] + " " + sorted_order[2] + " again" );
                
		return_order[sorted_order[0]]=0;      //The source with the lowest q-val gets the value 0
		return_order[sorted_order[1]]=1;
		return_order[sorted_order[2]]=2;
		
		m_prev_order=return_order;
                
                //m_msgParser.writeMyFile(m_log_filename,"Priorities of sources    " + m_prev_order[0] + " " + m_prev_order[1] + " " + m_prev_order[2]);
		return return_order;
	}
	
	final void SwitchVal(int x, int y, double [] array_to_switch)
	{
		double z;
	
		z=array_to_switch[x];
		array_to_switch[x]=array_to_switch[y];
		array_to_switch[y]=z;	
	}
	
	final void SwitchVal(int x, int y, byte [] array_to_switch)
	{
		byte z;
	
		z=array_to_switch[x];
		array_to_switch[x]=array_to_switch[y];
		array_to_switch[y]=z;	
	}

        //Write to screen	
	final void printQvalues()
	{
		System.out.println("Present Q values: ");
		
		for (i=0;i<numofstates;i++)
		{
			System.out.println("State: " + i );
			
			for(j=0;j<def_agent_action_num;j++)
				System.out.print("\t :" + m_q_values[i][j]);
			System.out.println("" );
		}
		
	}
	
	
	final void writeQvalues()
	{
		DataOutputStream dos;
		
		try{
			dos=new DataOutputStream(new FileOutputStream (m_q_filename,false));
			//WRITING THE Q VALUES
			try{
				for (i=0;i<numofstates;i++)
				{
					//dos.writeInt(i);
	
					for(j=0;j<def_agent_action_num;j++)
					{
						//dos.writeChar('\t');
						dos.writeDouble(m_q_values[i][j]);
					}
					//dos.writeChar('\n');		
				}
			}catch(Exception e){
				System.out.println("writeQvalues: could not write the q values");
			}
			//WRITING HOW MANY TIMES VISITED
			try{
				for (i=0;i<numofstates;i++)
				{
					//dos.writeInt(i);
			
					for(j=0;j<def_agent_action_num;j++)
					{
						//dos.writeChar('\t');
						dos.writeInt(m_q_trace[i][j]);
					}
					//dos.writeChar('\n');		
				}
			}catch(Exception e){
				System.out.println("writeQvalues: could not write the q value visit trace");
			}
		
			dos.close();
		}catch(Exception e){
			System.out.println("writeQvalues: problem with the file operation" );
		}
		
	}	
	
	final void readQvalues()
	{
		DataInputStream dis;
		
		try{
			dis=new DataInputStream(new FileInputStream (m_q_filename));
			try{
				for (i=0;i<numofstates;i++)
				{
					//dis.readInt();
					for(j=0;j<def_agent_action_num;j++)
					{
						//dis.readChar();
						m_q_values[i][j]=dis.readDouble();						
					}
					//dis.readChar();		
				}
			}catch(Exception e){
				System.out.println("readQvalues: Could not read the q values");
			}
		
			dis.close();
		}catch(Exception e){
			System.out.println("readQvalues: Problem with the file operation" );
		}
		
		
	}		
	
	final void writePvalues()
	{
		DataOutputStream dos;	
		try{
			dos=new DataOutputStream(new FileOutputStream (m_p_filename,false));
			//WRITING THE P VALUES
			try{
				for (i=0;i<numofstates;i++)
				{
					//dos.writeInt(i);
	
					for(j=0;j<def_action_source_num;j++)
					{
						//dos.writeChar('\t');
						dos.writeDouble(m_p_values[i][j]);
					}
					//dos.writeChar('\n');		
				}
			}catch(Exception e){
				System.out.println("writePvalues:Could not write the p values");
			}
			//WRITING HOW MANY TIMES VISITED
			try{
				for (i=0;i<numofstates;i++)
				{
					//dos.writeInt(i);
	
					for(j=0;j<def_action_source_num;j++)
					{
						//dos.writeChar('\t');
						dos.writeDouble(m_p_trace[i][j]);
					}
					//dos.writeChar('\n');		
				}
			}catch(Exception e){
				System.out.println("writePvalues: Could not write visit trace");
			}
			
			dos.close();
		}catch(Exception e){
			System.out.println("writePvalues: Problem with the file operation" );
		}
	}	
	
	final void readPvalues()
	{
		DataInputStream dis;
		try{
			dis=new DataInputStream(new FileInputStream (m_p_filename));
			try{
				for (i=0;i<numofstates;i++)
				{
					//dis.readInt();
				
					for(j=0;j<def_action_source_num;j++)
					{
						//dis.readChar();
						m_p_values[i][j]=dis.readDouble();
					}
					//dis.readChar();		
				}
			}catch(Exception e){
				System.out.println("readPvalues: Could not read the p values");
			}
			dis.close();
		}catch(Exception e){
			System.out.println("readPvalues: Problem with file operation" );
		}
	
	}
	
	final void writeStateVisitTraces(int [] state_trace, long [] time_trace, int training_num, int loop_count)
	{
		DataOutputStream dos;
		int iubound=numofstates;
		int jubound=def_action_source_num;
		
		try{
			dos=new DataOutputStream(new FileOutputStream (m_log_filename,true));
			dos.writeBytes("TRAINING NUMBER" + training_num + "\n");
                        dos.writeBytes("LOOP COUNT" + loop_count+ "\n");
                        dos.close();
                        dos=new DataOutputStream(new FileOutputStream (m_log_filename+ " 2",true));
			dos.writeBytes("P val visit trace:\n");
			try{
                                
				for (i=0;i<iubound;i++)
				{
					for(j=0;j<jubound;j++)
					{
							dos.writeBytes( m_p_trace[i][j]+"");
							dos.writeBytes(" ");
					}
					dos.writeBytes("\n");
				}
			}catch(Exception e){
				System.out.println("WRITE EXCEPTION in P visit to log file");
			}
			dos.close();
			dos=new DataOutputStream(new FileOutputStream (m_Pvisit_filename,false));
			try{
				for (i=0;i<iubound;i++)
				{
					for(j=0;j<jubound;j++)
					{
							dos.writeInt( m_p_trace[i][j]);
							
					}
				}
			}catch(Exception e){
				System.out.println("WRITE EXCEPTION in P visit to binary");
			}

			
			dos.close();
			
		iubound=numofstates;
		jubound=def_agent_action_num;	
		
			dos=new DataOutputStream(new FileOutputStream (m_log_filename+ " 2",true));
			dos.writeBytes("Q val visit trace:\n");
			try{
			
				for (i=0;i<iubound;i++)
				{
					for(j=0;j<jubound;j++)
					{
							dos.writeBytes( m_q_trace[i][j]+"");
							dos.writeBytes(" ");
					}
					dos.writeBytes("\n");
				}
			}catch(Exception e){
				System.out.println("WRITE EXCEPTION in q visit to log");
			}
			
			dos.close();
			
			dos=new DataOutputStream(new FileOutputStream (m_Qvisit_filename,false));
			try{
			
				for (i=0;i<iubound;i++)
				{
					for(j=0;j<jubound;j++)
					{
							dos.writeInt( m_q_trace[i][j]);
							
					}
				}
			}catch(Exception e){
				System.out.println("WRITE EXCEPTION in q visit to binary");
			}
			
			dos.close();		
			
			iubound=numofstates;
			dos=new DataOutputStream(new FileOutputStream (m_log_filename,true));
			dos.writeBytes("\nState visit trace:\n");
			try{
			
				for (i=0;i<iubound;i++)
				{
					dos.writeBytes( "-" + i + ":" + state_trace[i]+"");	
				}
			}catch(Exception e){
				System.out.println("WRITE EXCEPTION in state visit trace");
			}
			
			iubound=(int)time_trace.length;
                        dos.close();
                        /*
			dos=new DataOutputStream(new FileOutputStream (m_log_filename,true));
			dos.writeBytes("\nTime visit trace:\n");
			try{
				for (i=0;i<iubound;i++)
				{
                                           dos.writeBytes( i + " " + (time_trace[i*3+1] -time_trace[i*3]));
                                           
                                           if ( time_trace[i*3+1] -time_trace[i*3]> 500)
                                                dos.writeBytes(" *\n");
                                           else
                                                dos.writeBytes("\n");
                                                
                                           dos.writeBytes( "\t\t" + (time_trace[i*3+2] -time_trace[i*3+1]));
                                           
                                           if ( time_trace[i*3+2] -time_trace[i*3+1]> 500)
                                                dos.writeBytes(" **\n");
                                           else
                                                dos.writeBytes("\n");    
                                               
                                           if ((i+1)*3 < iubound)
                                           {
                                                dos.writeBytes( "\t\t\t\t" + (time_trace[(i+1)*3] -time_trace[i*3+2]));
                                           
                                                if ( time_trace[(i+1)*3]  -time_trace[i*3+2]> 2000)
                                                        dos.writeBytes(" ***\n");
                                                else
                                                        dos.writeBytes("\n");     
                                          } 
				}
			}catch(Exception e){
				System.out.println("WRITE EXCEPTION in file visit trace");
			}
			dos.close();	
			*/
		
		}catch(Exception e){
			System.out.println("IO EXCEPTION in writing traces" );
		}
	}
				
}

class ControllerLearningComponent implements Definitions
{
        
        double [] m_reward_function;            //Reward function is a step function
	double [][] m_q_values;
	int numofstates;
	String m_log_filename;
	String m_q_filename;
	Random randomgen;
	byte m_agent_index;
        int i,j;
        MessageParser m_msgParser;
        
	ControllerLearningComponent()
	{
		numofstates=DEF_NUM_MY_LEVELS;
		for(i=1;i<def_environment_types;i++)
			numofstates*=DEF_NUM_OTHER_LEVELS;
		//System.out.println("Number of states: " + numofstates);	
		m_q_values=new double[numofstates][def_controller_action_num];
		randomgen= new Random();
		randomgen.setSeed(System.currentTimeMillis());
                
                numofstates=DEF_NUM_MY_LEVELS;
		for(i=1;i<def_environment_types;i++)
			numofstates*=DEF_NUM_OTHER_LEVELS;
	
                m_msgParser=new MessageParser();
	
	m_reward_function=new double[numofstates];
                
                double max_reward[] = {16.0,12.0,12.0,8.0};
                double decrement[] = {1.0,0.75,0.75,0.5};
                       
                //CHANGE FOR NEWEST        
                for (j=0;j<4;j++)
		{
                        for (i=0;i<16;i++)
                        {
			     m_reward_function[16*j+i]=max_reward[j]-(i*decrement[j]);
			     //System.out.println("Reward " + (int)(16*j+i) + ": " + m_reward_function[16*j+i]);
                        }
		}
	}

	final void set_log_filename(String filename, byte agent_index)
	{
		m_log_filename=filename;
		m_agent_index=agent_index;
	}
	
	final void set_q_filename(String filename)
	{
		m_q_filename=filename;
	}

	final int get_current_state(double abstract_buildings,  double abstract_people, double abstract_roads)
	{
	
		double [] the_states;
		int overall_state;
		
		the_states=new double[def_environment_types];

		if (m_agent_index==WORLD_MODEL_FIREFIGHTER_INDEX)
		{
			the_states[0]=abstract_buildings;
			the_states[1]=abstract_roads;
			the_states[2]=abstract_people;
		}
		else if(m_agent_index==WORLD_MODEL_POLICE_INDEX)
		{
			the_states[0]=abstract_roads;
			the_states[1]=abstract_buildings;
			the_states[2]=abstract_people;
		}
		else 
		{
			the_states[0]=abstract_people;
			the_states[1]=abstract_buildings;
			the_states[2]=abstract_roads;
		}
		
		
		the_states[0]=(int)((double)the_states[0]*(double)DEF_NUM_MY_LEVELS);
		the_states[1]=(int)((double)the_states[1]*(double)DEF_NUM_OTHER_LEVELS);
		the_states[2]=(int)((double)the_states[2]*(double)DEF_NUM_OTHER_LEVELS);
		
		if (the_states[0]==DEF_NUM_MY_LEVELS) the_states[0]--;
		if (the_states[1]==DEF_NUM_OTHER_LEVELS) the_states[1]--;
		if (the_states[2]==DEF_NUM_OTHER_LEVELS) the_states[2]--;
		
		overall_state= DEF_NUM_MY_LEVELS *  ( (int)the_states[1] * DEF_NUM_OTHER_LEVELS  +  (int)the_states[2] ) + (int)the_states[0] ;
		return overall_state;
	}

	final void updateQvalues(int the_state, int the_action, double the_result, double reward_divisor)
	{
                
                //m_msgParser.writeMyFile(m_log_filename,"Updating q val state: " + the_state + " action: " + the_action + " result: " + the_result + " reward: " + m_reward_function[the_state] + "divisor" + reward_divisor);
                //m_msgParser.writeMyFile(m_log_filename,"Division" + (m_reward_function[the_state]/reward_divisor)); 
                //GREEDY
                /*
                the_result /= 100;
		m_q_values[the_state][the_action]+= def_learning_rate * (the_result + m_reward_function[the_state]/reward_divisor);
                */
	}
	
	final byte decideOnAction(int current_state)
	{
		double max_q_of_current_state=MY_MINDOUBLE;
		byte max_q_action=0;					
		byte random_action=0;
	
		for (i=0;i<def_controller_action_num;i++)
		{
			if (m_q_values[current_state][i] > max_q_of_current_state)
			{	
				max_q_of_current_state=m_q_values[current_state][i];
				max_q_action=(byte)i;
			}
		}		

		if (def_center_explorer)
		{
			if (randomgen.nextFloat() < def_center_accept_probability)
			{
				do{
					//random_action=(int)Math.round(randomgen.nextFloat()*(double)(def_controller_action_num-1));
                                        random_action=(byte)Math.floor(randomgen.nextFloat()*(double)(def_controller_action_num));
					if (random_action == def_controller_action_num) random_action--;
				}while(random_action==max_q_action);
				return random_action;
			}
		}

		return max_q_action;
		
	}

//print to screen
	final void printQvalues()
	{
	
		System.out.println("Present Q values: ");
		for (i=0;i<numofstates;i++)
		{
			System.out.println("State: " + i +  " Urgent: " + m_q_values[i][CONTROLLER_URGENT_FIRST] + " Closest: " + m_q_values[i][CONTROLLER_CLOSEST_FIRST]);
		}
		
	}
	
	
	
	
//print to binary file	
	final void writeQvalues()
	{
		DataOutputStream dos;
	
		try{
			
			dos=new DataOutputStream(new FileOutputStream (m_q_filename,false));
			
			for (i=0;i<numofstates;i++)
			{
				dos.writeDouble(m_q_values[i][CONTROLLER_URGENT_FIRST]);
				//dos.writeChar('\t');
				dos.writeDouble(m_q_values[i][CONTROLLER_CLOSEST_FIRST]);
				//dos.writeChar('\t');
				dos.writeDouble(m_q_values[i][CONTROLLER_URGENT_2_BY_2]);
				//dos.writeChar('\t');
				dos.writeDouble(m_q_values[i][CONTROLLER_CLOSEST_2_BY_2]);
				//dos.writeChar('\t');
				dos.writeDouble(m_q_values[i][CONTROLLER_URGENT_3_BY_3]);
				//dos.writeChar('\t');
				dos.writeDouble(m_q_values[i][CONTROLLER_CLOSEST_3_BY_3]);
				//dos.writeChar('\t');
				dos.writeDouble(m_q_values[i][CONTROLLER_LIGHTEST_1_BY_1]);
				//dos.writeChar('\t');
				dos.writeDouble(m_q_values[i][CONTROLLER_LIGHTEST_2_BY_2]);
				//dos.writeChar('\t');
				dos.writeDouble(m_q_values[i][CONTROLLER_LIGHTEST_3_BY_3]);
				//dos.writeChar('\n');
			}
			
			dos.close();
		}catch(Exception e){}
	}
	final void readQvalues()
	{
		DataInputStream dis;
		
		try{
			
			dis=new DataInputStream(new FileInputStream (m_q_filename));
		
			for (i=0;i<numofstates;i++)
			{
				m_q_values[i][CONTROLLER_URGENT_FIRST]=dis.readDouble();
				//dis.readChar();
				m_q_values[i][CONTROLLER_CLOSEST_FIRST]=dis.readDouble();
				//dis.readChar();
				m_q_values[i][CONTROLLER_URGENT_2_BY_2]=dis.readDouble();
				//dis.readChar();
				m_q_values[i][CONTROLLER_CLOSEST_2_BY_2]=dis.readDouble();
				//dis.readChar();
				m_q_values[i][CONTROLLER_URGENT_3_BY_3]=dis.readDouble();
				//dis.readChar();
				m_q_values[i][CONTROLLER_CLOSEST_3_BY_3]=dis.readDouble();
				//dis.readChar();
				m_q_values[i][CONTROLLER_LIGHTEST_1_BY_1]=dis.readDouble();
				//dis.readChar();
				m_q_values[i][CONTROLLER_LIGHTEST_2_BY_2]=dis.readDouble();
				//dis.readChar();
				m_q_values[i][CONTROLLER_LIGHTEST_3_BY_3]=dis.readDouble();
				//dis.readChar();
			}
			
			dis.close();
		}catch(Exception e){}
		
		
	}

	
}



