import java.io.*;

class MessageParser implements Definitions
{


	MessageParser()
	{
	}

	final int get_msg_type(byte [] message_full)
	{	
	 	return byteArrtoInt(message_full,MSG_FORMAT_TYPE_INDEX,4);
	}

	final int get_msg_type_long_packet(int [] message_full)
	{	
	 	return message_full[MSG_FORMAT_LONG_TYPE_INDEX];
	}

	final int get_msg_size(byte [] message_full)
	{	
	 	return byteArrtoInt(message_full,MSG_FORMAT_SIZE_INDEX,4);
	}
/*
	int get_sender(byte [] message_full)
	{	
	 	return byteArrtoInt(message_full,MSG_FORMAT_HEAR_SENDER_INDEX,4);
	}
*/
	//message_full contains the 12 byte info (2) msg_type + (10)subject_id
	//This function gets the 2 byte msg_type
	final String get_KA_HEAR_type(byte [] message_full)
	{
		return new String(byteArrCopy(message_full,MSG_FORMAT_HEAR_TYPE_INDEX,2));
	}
	
	//message_full contains the 12 byte info (2) msg_type + (10)subject_id
	//This function gets the 10 byte subject_id
	final String get_KA_HEAR_subject(byte [] message_full,int body_detail_size)
	{
		return new String(byteArrCopy(message_full,MSG_FORMAT_HEAR_SUBJECT_INDEX,body_detail_size-2));
	}

	final int byteArrtoInt (byte [] byteArr, int start, int length)
	{
		int i;
		int out;
	
		out=0;

		for (i=0;i<length;i++)
		{
			//out= (int) ( (((int)out& 0xff)<<8) | ((int)byteArr[start+i]& 0xff) );
			  out= (256*out) + ((int)byteArr[start+i]& 0xff);
		}
		return out;
	}

	//
	final int [] byteArrtoIntArr (byte [] byteArr, int start, int byte_length)
	{
		int i,j;
		int [] out;
		int int_length;
		
		int_length=byte_length/4;
		out=new int[int_length];
	
/*THIS CODE CAN ONLY CONVERT TWO BYTES FOR UNKNOWN REASONS
		for (i=0;i<int_length;i++)
		{
			for (j=0;j<4;j++) //integer=4 bytes
			{
				out[i]= (int) ( (((int)out[i] & 0xff)<<8) | ((int)byteArr[start+i*4+j]& 0xff) );
			}
		}
*/

		for (i=0;i<int_length;i++)
		{
			for (j=0;j<4;j++) //integer=4 bytes
			{	
				out[i]= (256*out[i]) + ((int)byteArr[start+i*4+j]& 0xff);
			}
		}
	
		return out;
	}

	final byte [] intArrtoByteArr ( int [] intArr, int start,int int_length )
	{
		int i,j;
		byte [] out;
		int byte_length;
		
		byte_length=int_length*4;
		out=new byte[byte_length];
	
		//System.out.println("intArrtoByteArr: Length of message:" + intArr.length);
		//System.out.println("intArrtoByteArr: Start:" + start);
		//System.out.println("intArrtoByteArr: length:" + int_length);

//indicated int_length may be shorter or longer than the actual int array size, minimum should be returned...
	
		for (i=start;(i<intArr.length && i<start+int_length);i++)
		{		
				//System.out.println("intArrtoByteArr: intArr[i] contains:" + intArr[i]);

				out[(i-start)*4]= 	(byte) (intArr[i]>>>(8*3) & 0xff);
				out[(i-start)*4+1]= (byte) (intArr[i]>>>(8*2) & 0xff);
				out[(i-start)*4+2]= (byte) (intArr[i]>>>(8*1) & 0xff);
				out[(i-start)*4+3]= (byte) (intArr[i] & 0xff);
		}
		return out;
	}
	
	final byte [] inttoByteArr ( int intArr )
	{
		int i,j;
		byte [] out;
		int byte_length;
		int int_length=1;
		int start=0;
		
		byte_length=int_length*4;
		out=new byte[byte_length];
	
				out[0]= (byte) (intArr>>>(8*3) & 0xff);
				out[1]= (byte) (intArr>>>(8*2) & 0xff);
				out[2]= (byte) (intArr>>>(8*1) & 0xff);
				out[3]= (byte) (intArr & 0xff);
		
		return out;
	}

	final byte [] byteArrCopy (byte [] byteArr, int start, int length)
	{
		int i;
		byte [] out;
	
		out=new byte[length];

		for (i=0;i<length;i++)
		{
			out[i]=byteArr[start+i];
		}
		return out;
	}

	final int [] combinePackets(int [][] packets)
	{
		int i;
		int totalSize=0;
		int written=0;
		int length=0;
		int [] combinedPacket;
		
		for(i=0;i<packets.length;i++)
			totalSize+=packets[i].length;

		combinedPacket=new int[totalSize];
		for(i=0;i<packets.length;i++)
		{
			length=packets[i].length;
			System.arraycopy(packets[i],0,combinedPacket,written,length);
			written+=length;
		}
		
		return combinedPacket;
	}


	final void writeMyFile(String filename, String mylog) 
	{
		try{
		FileWriter writeTofile= new FileWriter(filename,true);
		PrintWriter cout=new PrintWriter(new BufferedWriter(writeTofile));

		
			cout.println(mylog);
			cout.close();
			
		}catch(Exception e){}
	}

	final HeardInfo parseKA_HEAR(int [] full_message)
	{
		HeardInfo heard=new HeardInfo();
		byte [] message_details;


		//int r;
		//	for (r=0;r<full_message.length;r++)
		//		System.out.println("msg" + r + " " +full_message[r]);

		//message_details=intArrtoByteArr ( full_message, MSG_FORMAT_HEAR_MSG_DETAILS,(msgtype_len+subj_len)/4 );
		message_details=intArrtoByteArr ( full_message, MSG_FORMAT_HEAR_MSG_DETAILS,(msgtype_len+subj_len+agent_len)/4 );


		//int r;
		//	for (r=0;r<message_details.length;r++)
		//		System.out.println("msg" + r + " " +message_details[r]); 	

		/*try{
		heard.detail=Integer.parseInt( new String(byteArrCopy(message_details,0,msgtype_len)));
		}catch(Exception e){}
		try{
		heard.subject=Integer.parseInt( new String(byteArrCopy(message_details,msgtype_len,subj_len)));
		}catch(Exception e){}*/
		try{
		heard.detail=Integer.parseInt( new String(byteArrCopy(message_details,0,msgtype_len)));
		}catch(Exception e){}
		try{
		heard.subject=Integer.parseInt( new String(byteArrCopy(message_details,msgtype_len,subj_len)));
		}catch(Exception e){}
		try{
		heard.agent=Integer.parseInt( new String(byteArrCopy(message_details,msgtype_len+subj_len,agent_len)));
		}catch(Exception e){}
		
		
		return heard;
	
	}
	

}

//Class that is store the packets of a long message
class MessageSorter
{

int id;
int totalCount;
int rcvCount;
int [][]messages;

}

class HeardInfo
{
	int size;
	int detail;
	int subject;
	int agent;

	HeardInfo()
	{
		size=-1;
		detail=-1;
		subject=-1;
		agent=-1;
	}
}
