import java.io.*;
import java.util.*;

class PoliceTeam extends AgentThd
{

	int intermediate_target_for_move;
	int intermediate_target_for_clear;
	DataOutputStream dos;
	
	

	PoliceTeam(int agent_type, String prefix, String inetaddr, int training_run_num)
	{
		super(agent_type,prefix,inetaddr, training_run_num);
	}


	final void SetAgentSpecificConstants()
	{
		m_agent_index=WORLD_MODEL_POLICE_INDEX;
		m_target_index=WORLD_MODEL_ROAD_INDEX;
		intermediate_target_for_move=0;
		intermediate_target_for_clear=0;
		m_execute_base=MSG_POLICE_EXECUTE;
		//m_timeout=DEF_POLICE_TIME_OUT;
		m_positive_reward=POLICE_REWARD;
	}

	//This function is called from handle preemption
	//It is to determine whether the police reached its job
	//In order not to preempt in such a case
	final boolean PoliceFoundTarget()
	{
		if ( m_myself.get_position()==m_current_job.target_id)
                {
                        //m_msgParser.writeMyFile(m_filename,"Police found target" );
			return true;
                }
		if (we_are_at instanceof Node)
		{
			int [] edges;
			int i;
				
			edges=((Node)we_are_at).get_edges();
			for(i=0;i<edges.length;i++)
			{
				if (edges[i]==m_current_job.target_id) 
				{
					return true;
				}
			}
		}
                //m_msgParser.writeMyFile(m_filename,"Police did not found target" );
		return false;
	}

	final byte ArrivedToTarget()
	{
		SimObject road_on_the_way;
	
		if ( m_myself.get_position()==m_current_job.target_id)
			return ARRIVED_TO_TARGET;	

			if (we_are_at instanceof Node)
			{

				int [] edges;
				int i;
				
				edges=((Node)we_are_at).get_edges();
				for(i=0;i<edges.length;i++)
				{
					if (edges[i]==m_current_job.target_id) 
					{
						if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"Target road yanindaki nodea geldik");	
						return ARRIVED_TO_TARGET;
					}
                                        
				}	
			}
                        
		return NOT_ARRIVED_TO_TARGET;

	}
	
	
	//A police officer can always save a road
	final byte targetRuined(Job this_job)
	{
		return NOT_RUINED;
	}
	
	final byte targetSaved()
	{
	
		if (m_current_job.target_object==null)
		{
			//m_msgParser.writeMyFile(m_filename,"TakeAction: Target object is null.");
			return JOB_STATUS_UNKNOWN;
		}
		if (m_world_model.clear(m_current_job.target_object) &&  ArrivedToTarget()==ARRIVED_TO_TARGET) 
		{
			if (m_current_job.took_action )
			{
                                //m_msgParser.writeMyFile(m_filename,"Saved by me.");
				return SAVED_BY_ME;
			}
			else
			{
                                //m_msgParser.writeMyFile(m_filename,"Saved by other");
				return SAVED_BY_OTHER;
			}
		}
                //m_msgParser.writeMyFile(m_filename,"Not saved yet.");
		return NOT_SAVED_YET;
	}

	final void takeAction()
	{
	
	//If the target is OK or lost this is determined beforehand, thus this function only deals with the 'not arrived to target' and 'arrived to target but not finished the job' cases

	if (!current_action_done)
	{
		m_current_job.cycles_spent_on_job++;
		int resultArrivedToTarget;
		
		if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction: target "+m_current_job.target_id);
	
		resultArrivedToTarget=ArrivedToTarget();
		
		if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction: resultArrivedToTarget "+resultArrivedToTarget);
		
		if (resultArrivedToTarget==NOT_ARRIVED_TO_TARGET)
		{
			if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction: not arrived sending move "+m_current_job.target_id);
			moveTo(m_current_job.target_id,false); //WE SHALL NOT REMOVE LAST,BUG WAS HOPEFULLY FILLED IN NEW VERSION OF TRAFFIC SIM... 18/4/2002//we shall remove last, it is blocked, we cannot go there
		}
		else if (resultArrivedToTarget==MOVE_TO_INTERMEDIATE_TARGET)
		{
			
			if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction: intermediate move "+intermediate_target_for_move);
			moveTo(intermediate_target_for_move,false);
		
		}
		else if (resultArrivedToTarget==CLEAR_INTERMEDIATE_TARGET)
		{
			
			if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction: intermediate clear "+intermediate_target_for_clear);
			
			m_io.send_two_int_msg(AK_CLEAR,m_id, intermediate_target_for_clear);
                        m_router.reset_next_cycle=true;
			current_action_done=true;
		}
		else if (m_world_model.saveable(m_current_job.target_object))
		{
			if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction: found target sending clear "+m_current_job.target_id);
			m_io.send_two_int_msg(AK_CLEAR,m_id, m_current_job.target_id);
                        m_router.reset_next_cycle=true;
			current_action_done=true;
			m_current_job.took_action=true;
		}
		else
		{
			if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction: target found but not saveable ????");
			resetJobIndicators(m_current_job.target_id);
                        handleCenterReply(m_current_job, MSG_NEUTRAL_POS);      //Unsaveable road is always clear
		}
	  }//Current action done test	
	}
        
        
        final byte ArrivedToTargetRandom()
	{
		SimObject road_on_the_way;
	
		if ( m_myself.get_position()==random_object.get_id())
			return ARRIVED_TO_TARGET;	

			if (we_are_at instanceof Node)
			{

				int [] edges;
				int i;
				
				edges=((Node)we_are_at).get_edges();
				for(i=0;i<edges.length;i++)
				{
					if (edges[i]==random_object.get_id()) 
					{
						if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"Arrived Random: Target road yanindaki nodea geldik");	
						return ARRIVED_TO_TARGET;
					}
					//If this is an edge in front of us
					else if (m_router.m_position_history.indexOf(new Integer(m_myself.get_position()))> m_router.m_position_history.indexOf(new Integer(edges[i])))
						{
							road_on_the_way=(SimObject)m_world_model.getObjectbyId( edges[i]);
							//BU COMPLETELY CLEAR ETMEK ICIN
							if (road_on_the_way.get_type()==TYPE_ROAD)
							{
								//if (!m_world_model.clear(road_on_the_way))
								if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"passable " + m_world_model.passable(road_on_the_way,we_are_at));
								if (!m_world_model.passable(road_on_the_way,we_are_at))
								{
									if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"Arrived Random: Baska block road yanindayiz");
									intermediate_target_for_clear=edges[i];
									
									if (!(m_excluded_targets.contains(new Integer(intermediate_target_for_clear))))
									{
										m_excluded_targets.add(new Integer(intermediate_target_for_clear));
									}
									return CLEAR_INTERMEDIATE_TARGET; 
								}
							}	
						}
                                       
				}	
			}	
			if (we_are_at instanceof Road)
			{
				if (!m_world_model.clear(we_are_at))
				{
					if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"Arrived Random: Baska bir block road uzerindeyiz");
					intermediate_target_for_clear=m_myself.get_position();
					if (!(m_excluded_targets.contains(new Integer(intermediate_target_for_clear))))
					{
			             		m_excluded_targets.add(new Integer(intermediate_target_for_clear));
					}
					return CLEAR_INTERMEDIATE_TARGET; //This is not actually our target but we shall clear it
				}		
			}
		return NOT_ARRIVED_TO_TARGET;

	}

	final void takeActionRandom()
	{
	
	//If the target is OK or lost this is determined beforehand, thus this function only deals with the 'not arrived to target' and 'arrived to target but not finished the job' cases

          if (!current_action_done)
	  {
		int resultArrivedToTarget;
		
		resultArrivedToTarget=ArrivedToTargetRandom();
		
		if (resultArrivedToTarget==NOT_ARRIVED_TO_TARGET)
		{
                     if (random_object instanceof Building)
		        moveTo(random_object.get_id(),true);
                     else
			moveTo(random_object.get_id(),false); 
		}
		else if (resultArrivedToTarget==MOVE_TO_INTERMEDIATE_TARGET)
		{
			
			if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction Random: intermediate move "+intermediate_target_for_move);
			moveTo(intermediate_target_for_move,false);
		
		}
		else if (resultArrivedToTarget==CLEAR_INTERMEDIATE_TARGET)
		{
			
			if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction Random: intermediate clear "+intermediate_target_for_clear);
			
			m_io.send_two_int_msg(AK_CLEAR,m_id, intermediate_target_for_clear);
                        m_router.reset_next_cycle=true;
			current_action_done=true;
		}
		else if (m_world_model.saveable(random_object))
		{
                        m_io.send_two_int_msg(AK_CLEAR,m_id, random_object.get_id());
                        m_router.reset_next_cycle=true;
			current_action_done=true;
		}
		else
		{
			if (POL_LOGGING) m_msgParser.writeMyFile(m_filename,"TakeAction Random: target found but not saveable ????");        
                        random_object = null;
		}	
	  }//Current action done test	
	}
        
        final void takeActionRandomArrived()
	{
	
	//If the target is OK or lost this is determined beforehand, thus this function only deals with the 'not arrived to target' and 'arrived to target but not finished the job' cases

          if (!current_action_done)
	  {
                  int intermediate_target_for_clear = -1;
	          SimObject road_on_the_way;
                        if (we_are_at instanceof Node)
			{

				int [] edges;
				int i;
				
				edges=((Node)we_are_at).get_edges();
				for(i=0;i<edges.length;i++)
				{
					road_on_the_way=(SimObject)m_world_model.getObjectbyId( edges[i]);
					//BU COMPLETELY CLEAR ETMEK ICIN
					if (road_on_the_way.get_type()==TYPE_ROAD)
					{
						if (!m_world_model.passable(road_on_the_way,we_are_at))
						{
							intermediate_target_for_clear=edges[i];
									
							if (!(m_excluded_targets.contains(new Integer(intermediate_target_for_clear))))
							{
								m_excluded_targets.add(new Integer(intermediate_target_for_clear));
							}		
						}
					}
				}	
			}	
			if (we_are_at instanceof Road)
			{
				if (!m_world_model.clear(we_are_at))
				{   
                                        intermediate_target_for_clear=m_myself.get_position();
					if (!(m_excluded_targets.contains(new Integer(intermediate_target_for_clear))))
					{
			             		m_excluded_targets.add(new Integer(intermediate_target_for_clear));
					}
				}		
			}
        
                if (intermediate_target_for_clear>0)
                {
                        m_io.send_two_int_msg(AK_CLEAR,m_id, intermediate_target_for_clear);
                        m_router.reset_next_cycle=true;
			current_action_done=true;
		}	
	  }//Current action done test	
	}
        
        final SimObject findMaxSeverity(int m_x, int m_y, int current_time, Job current_target)
        {
                 return m_world_model.findMaxSeverity_road(m_x,m_y,current_target);
        }
        
        
        final double getStatusOfJob(Job theJob)
        {
                return ((Road)theJob.target_object).get_repairCost();
        }
        
        final void setStatusOfJob(Job theJob)
        {
                theJob.initial_status=((Road)theJob.target_object).get_repairCost();
        }
        
        final double compareStatuswithOld(Job theJob)
        {
                        //No one has cleared this road yet		
			if (theJob.initial_status==((Road)theJob.target_object).get_repairCost())
				return -QUEUE_REWARD;
			//Road is in better condition
			else
			{ 
				if (!m_world_model.saveable(theJob.target_object))
				{
					handleCenterReply(theJob, MSG_NEUTRAL_POS);
					removeFromJobQueue(theJob);					
				}
				return QUEUE_REWARD;
			}
        }
        
        //When this function is called theJob is already known to be unsaveable
        final double compareStatuswithOldUnsaveable(Job theJob)
        {
                handleCenterReply(theJob, MSG_NEUTRAL_POS);
		removeFromJobQueue(theJob);
		return ACCUMULATED_REWARD;
        }
}
