import java.io.*;
class QPNormalizer implements Definitions
{

public static void main(String args[]) throws IOException
	{
		
		avgFinder(11,64,3,"PFFI","PVisitFFI");
		//avgFinder(5,64,3,"PAMB","PVisitAMB");
		avgFinder(11,64,3,"PPOL","PVisitPOL");
		avgFinder(11,64,3,"QFFI","QVisitFFI");
		avgFinder(11,64,3,"QPOL","QVisitPOL");
		//avgFinder(5,64,3,"QAMB","QVisitAMB");
	}


	static void avgFinder( int filenum, int statenum, int actionnum, String fileprefix, String visitprefix)
	{
	
		DataInputStream values[];
		DataInputStream visitTrace[];
		FileInputStream x;
		int i,j,k;
		double avg_p_vals[][];
		double total_val=0.0;
		double current_val=0.0;
		int visit_val=0;
       		int num_visitors=0;
                boolean one_file_open=false;
				
		try{
			
			values=new DataInputStream[filenum];
			visitTrace=new DataInputStream[filenum];
			avg_p_vals=new double[statenum][actionnum];
			//System.out.println("1");
			
                        //DOSYALARI OKUYUP ARRAYLERE DOLDURUYORUZ
			for (i=0; i<filenum; i++)
			{
				
				try{
					values[i]=new DataInputStream(new FileInputStream (fileprefix + i + ".txt"));
                                        one_file_open = true;
				}
				catch(Exception e)
				{
				        System.out.println("COULD NOT open file " + fileprefix + i + ".txt");
					values[i]=null;
				}
			
				try{
					x = new FileInputStream (visitprefix + i + ".txt");
					visitTrace[i]=new DataInputStream(x);
					
				}
				catch(Exception e)
				{
					System.out.println("COULD NOT open file " + visitprefix + i + ".txt");
					visitTrace[i]=null;
				}
			}
			

                        if (!one_file_open) return;        
			
			//System.out.println("2");			
				for (i=0;i<statenum;i++)  //loop the states
				{
									
					for (j=0;j<actionnum;j++)  //loop the actions
					{
						//System.out.println(fileprefix +" state " + i + " " + j);
						for(k=0;k<filenum;k++)  //Loop the files
						{
                                                        //Eger value dosyasini okuyamamissa, o dosya averagea etki etmiyor
							if (values[k]!=null)
							{
			                                        try{
								        current_val = values[k].readDouble();
                                                                }catch(Exception e){
			                                     	       System.out.println("A file read error in file or visit file" + fileprefix  + k );
			                                        }
                                                                
                                                                //Eger visit dosyasini okuyamamissa, o dosya averagea etki etmiyor                                        
								if (visitTrace[k]==null)
									visit_val=0;
								else
									visit_val = visitTrace[k].readInt();
								
								if (visit_val>0)
								{
									num_visitors += 1;
									total_val += current_val;
								}
							}	
						}	
						
						if (num_visitors>0)
						{
							avg_p_vals[i][j] = total_val/(double)num_visitors;
							//System.out.println(fileprefix +" state " + i + " " + j + ":" + num_visitors);
						}
						else
						{
							avg_p_vals[i][j] = current_val;
						}
                                                current_val=0.0;
						total_val=0.0;
						num_visitors=0;
                                                visit_val=0;
					}
				
				}
			
			
			for (i=0; i<filenum; i++)
			{
				if (values[i]!=null)
					values[i].close();
				if (visitTrace[i]!=null)
					visitTrace[i].close();
			}
			
			for (i=0; i<filenum; i++)
			{
				writePvalues (fileprefix + i + ".txt",avg_p_vals,statenum,actionnum);
			}
			
		}catch(Exception e){
			System.out.println("IO EXCEPTION" );
		}
	
	}

	static void writePvalues(String p_filename , double [][] pvals, int statenum, int actionnum)
	{
			DataOutputStream dos;	
			try{
					dos=new DataOutputStream(new FileOutputStream (p_filename,false));
					try{
			
						int i,j;
						for (i=0;i<statenum;i++)
						{
							for(j=0;j<actionnum;j++)
							{
								dos.writeDouble(pvals[i][j]);
							}
						}
					}catch(Exception e){
						System.out.println("writePvalues: Error while writing data");
					}
					dos.close();
				}catch(Exception e){
							System.out.println("writePvalues: Error while opening file" );
				}
	}


}
