

//LEV0
abstract class SimObject implements Definitions
{
	int m_id;
	int m_type;
	int m_assignedTo;
	int m_routelevel;

	void set_id(int id) {m_id=id;}
	void set_type(int type) {m_type=type;}
	void set_assignedTo(int othersid) {m_assignedTo=othersid;}

	int get_id() {return m_id;}
	int get_type() {return m_type;}
	int get_assignedTo() {return m_assignedTo;}

	void setproperty(int property,int [] value)
	{
	}
	
}

//LEV1
class StaticObject extends SimObject
{

	int m_x;
	int m_y;

	int get_x(){return m_x;}
	int get_y(){return m_y;}

	void setproperty(int property,int [] value)
	{
		switch(property)
		{
			case PROPERTY_X: m_x=value[0]; break;
			case PROPERTY_Y: m_y=value[0]; break;
			default:super.setproperty(property,value); break;
		}
	}
}

//LEV2
class World extends SimObject
{
	//IS NOT USED IN PROGRAM, DONE IN CASE IT WILL BE USED LATER
	void setproperty(int property,int [] value)
	{
		switch(property)
		{
			default:super.setproperty(property,value); break;
		}
	}
	
}

//LEV2
class Edge extends StaticObject
{
	int m_head;		//Id of object at head
	int m_tail;		//Id of object at tail
	int m_length;

	int get_head(){return m_head;}
	int get_tail(){return m_tail;}
	int get_length(){return m_length;}
	
	void setproperty(int property,int [] value)
	{
		switch(property)
		{
			case PROPERTY_HEAD: m_head=value[0]; break;
			case PROPERTY_TAIL: m_tail=value[0]; break;
			case PROPERTY_LENGTH: m_length=value[0]; break;
			default:super.setproperty(property,value); break;
		}
	}
}

//LEV3
class Road extends Edge
{

//NOT USED  int m_roadKind;
  int m_carsPassToHead;
  int m_carsPassToTail;
  int m_humansPassToHead;
  int m_humansPassToTail;
  int m_width;
  int m_block;
  int m_repairCost;
//NOT USED  boolean m_medianStrip;
  int m_linesToHead;
  int m_linesToTail;
  int m_widthForWalkers;	
  int m_length;
  boolean confirmed;
  
//  int get_roadKind() { return m_roadKind; }
  final int get_carsPassToHead() { return m_carsPassToHead; }
  final int get_carsPassToTail() { return m_carsPassToTail; }
  final int get_humansPassToHead() { return m_humansPassToHead; }
  final int get_humansPassToTail() { return m_humansPassToTail; }
  final int get_width() { return m_width; }
  final int get_block() { return m_block; }
  final int get_repairCost() { return m_repairCost; }
//  boolean get_medianStrip() { return m_medianStrip; }
  final int get_linesToHead() { return m_linesToHead; }
  final int get_linesToTail() { return m_linesToTail; }
  final int get_widthForWalkers() { return m_widthForWalkers; }
  final int get_length() { return m_length; }

	Road ()
	{
		super();
		confirmed=false;
	}

	void setproperty(int property,int [] value)
	{
		switch(property)
		{				
			case PROPERTY_CARS_PASS_TO_HEAD:m_carsPassToHead=value[0]; break;
			case PROPERTY_CARS_PASS_TO_TAIL:m_carsPassToTail=value[0]; break;
			case PROPERTY_HUMANS_PASS_TO_HEAD:m_humansPassToHead=value[0]; break;
			case PROPERTY_HUMANS_PASS_TO_TAIL:m_humansPassToTail=value[0]; break;
			case PROPERTY_WIDTH:m_width=value[0]; break;
			case PROPERTY_BLOCK:m_block=value[0]; break;
			case PROPERTY_REPAIR_COST:
				m_repairCost=value[0]; 
				break;
			case PROPERTY_LINES_TO_HEAD:m_linesToHead=value[0]; break;
			case PROPERTY_LINES_TO_TAIL:m_linesToTail=value[0]; break;
			case PROPERTY_WIDTH_FOR_WALKERS:m_widthForWalkers=value[0]; break;
			case PROPERTY_LENGTH:m_length=value[0]; break;
			
			default:super.setproperty(property,value); break;
		}
	}

	final int get_aliveLinesToHead()
	{
		int result=m_linesToHead-blockedLines();
		if (result<0)
			return 0;
		else
			return result;
	}

	final int get_aliveLinesToTail()
	{
		int result=m_linesToTail-blockedLines();
		if (result<0)
			return 0;
		else
			return result;
	}

	final int blockedLines()
	{
		double lineDouble;
	
		double lineWidth=((double) m_width)/ (double) (m_linesToHead+m_linesToTail);
		double blockageWidth=((double) m_block)/2.0;
		lineDouble=(blockageWidth/lineWidth);
		return (int)Math.floor(lineDouble+0.5);
	}
}

//LEV3
class River extends Edge
{}

//LEV2
class Building extends StaticObject
{

//boolean m_ignition;  //BUNUNLA ILGILI BIR SORUN MU VAR?
  int m_fieryness;
  int m_brokenness;
  int[] m_entrances;
//boolean m_entrancesAreChanged;
//Domain m_entrancesSet;
//int m_buildingCode;
int m_buildingAreaGround;
int m_buildingAreaTotal;
//int[] m_buildingApexes;
  int m_fire_start_time;
  byte m_fire_reported;

  final int get_fieryness() { return m_fieryness; }
  final int get_brokenness() { return m_brokenness; }
  final int[] get_entrances() { return m_entrances; }
	void setproperty(int property,int [] value)
	{
		switch(property)
		{		
			case PROPERTY_FIERYNESS:m_fieryness=value[0]; break;
			case PROPERTY_BROKENNESS:m_brokenness=value[0]; break;
			case PROPERTY_ENTRANCES:m_entrances=value; break;
			case PROPERTY_BUILDING_AREA_GROUND:
				m_buildingAreaGround=value[0];
				break;
			case PROPERTY_BUILDING_AREA_TOTAL:
				m_buildingAreaTotal=value[0];
				break;	
                        //case PROPERTY_BUILDING_CODE:
                        //        System.out.println ("Building code is" + value[0]);
                        //        break;
                       
			default:super.setproperty(property,value); break;
		}
	}
}

//LEV3
class AmbulanceCenter extends Building
{
}

//LEV3
class PoliceStation extends Building
{}

//LEV3
class FireStation extends Building
{}

//LEV3
class Refuge extends Building
{}

//LEV2
class Node extends StaticObject
{
  int[] m_edges;

  final int[] get_edges() { return m_edges; }

	void setproperty(int property,int [] value)
	{
		switch(property)
		{
			case PROPERTY_EDGES:m_edges=value; break;
			default:super.setproperty(property,value); break;
		}
	}
}

//LEV3
class RoadNode extends Node
{}

//LEV3
class RiverNode extends Node
{}

//LEV1
class MovingObject extends SimObject
{
	int m_position;
 	int m_positionExtra;
	int [] m_positionHistory;
	
	int m_stamina;
  	int m_hp;
  	int m_damage;
  	int m_buriedness;
  	
  	int m_execute_message;

	final int get_position() { return (int)m_position; }
  	final int get_positionExtra() { return m_positionExtra; }
	final int [] get_positionHistory() { return m_positionHistory; }

  	final int get_stamina() { return m_stamina; }
 	final int get_hp()      { return m_hp; }
 	final int get_damage()  { return m_damage; }
 	final int get_buriedness() { return m_buriedness; }

	void setproperty(int property,int [] value)
	{
		switch(property)
		{
			case PROPERTY_POSITION:m_position=value[0]; break;
			case PROPERTY_POSITION_EXTRA:m_positionExtra=value[0]; break;
			case PROPERTY_POSITION_HISTORY:m_positionHistory=value; break;
			case PROPERTY_STAMINA:m_stamina=value[0]; break;
			case PROPERTY_HP:m_hp=value[0]; break;
			case PROPERTY_DAMAGE:m_damage=value[0]; break;
			case PROPERTY_BURIEDNESS:m_buriedness=value[0]; break;

			default:
		
					super.setproperty(property,value); break;
		}
	}
	
}

//LEV2
class Civilian extends MovingObject
{}


//LEV2
class Car extends MovingObject
{}


//LEV2
class FireFighter extends MovingObject
{

	int m_waterquantity;
	int m_stretchedlength;

	final int get_waterquantity() { return m_waterquantity; }
 	final int get_stretchedlength()      { return m_stretchedlength; }

	void setproperty(int property,int [] value)
	{
		switch(property)
		{
			case PROPERTY_WATER_QUANTITY:m_waterquantity=value[0]; break;
			case PROPERTY_STRETCHED_LENGTH:m_stretchedlength=value[0]; break;
			
			default:super.setproperty(property,value); break;
		}
	}
}


//LEV2
class Ambulance extends MovingObject
{}


//LEV2
class PoliceOfficer extends MovingObject
{}


