import java.util.*;
import java.io.*;

class WorldModel implements Definitions 
{
	
	Hashtable [] the_world;			//Each element contains a hashtable of buildings, roads and civilians
	
	int num_burning=0;			
	int num_injured=0;                      //Counted in order to be able to report injured civilians
	int num_blocked=0;
	int num_blocked_w_civ=0;
        
        double abstract_buildings;		//ABSTRACT NOTATION TO BE ABLE TO INDEX Q VALUES
	double abstract_people;
	double abstract_roads;

	
	int m_id=0;
	
	Hashtable objectsAroundHere;           //Environment info received in the latest cycle
	Hashtable oldAroundHere;               //Environment info received in the previous cycle
	Hashtable positionsofMovingObjs;       //The above two are used to form this hashtable. This hashtable is used in the 
                                               //Route finder to determine agents in neighbor cells
                                               //To determine targets for police officers (someone must be on the roads)
	Vector ingoredJobsofPolice;
	MessageParser msgParser;
	String w_filename;
	Random randomgen;
        Vector [] fieryBuildings;
        Vector targets_tobe_saved;              //Targets are sought from this vector
        Vector buildings_tobe_reported;         //Buildings that will be reported as fiery
        
        SimObject parser_current_object;
	int parser_object_id;
	int parser_object_type;
	int parser_prop_type;
	int parser_i,parser_j;
	int parser_world_index;
        int parser_arrsize;
        int [] parser_value;
        double total_area;

	WorldModel()
	{
		int i;
		
		//Create the hashtables for the world and agents
		
		the_world=new Hashtable [def_environment_types+def_agent_num+def_other_num];
		for (i=0;i<the_world.length;i++)
			the_world[i]=new Hashtable();
		objectsAroundHere= new Hashtable();
		positionsofMovingObjs= new Hashtable();
		ingoredJobsofPolice = new Vector();
                targets_tobe_saved = new Vector();
                buildings_tobe_reported = new Vector();
		msgParser=new MessageParser();
		randomgen= new Random();
		randomgen.setSeed(System.currentTimeMillis());
	        fieryBuildings = new Vector[EXTINGUISHED_BUILDING1];
                for (i=0; i<EXTINGUISHED_BUILDING1; i++)
                {
                        fieryBuildings[i] = new Vector();
                }
                total_area = 0;
	}
	
	final void setFilename(String xw_filename)
	{
		w_filename=xw_filename;
	}

	final void setId(int ID)
	{
		m_id=ID;	
	}

        final double get_abstract_buildings()
	{
		return abstract_buildings;
	}

	final double get_abstract_people()
	{
		return abstract_people;
	}

	final double get_abstract_roads()
	{
		return abstract_roads;
	}
        
        final double fn_calculate_abstract_buildingsC(int m_agent_type)
	{
                /*
		int i;
		int num_burnt=0;
		int num_ok=0;
		Building temp_building;
		Integer temp_index;
		int fieryness;
		double result;

		num_burning=0;
		Iterator it=the_world[WORLD_MODEL_BUILDING_INDEX].keySet().iterator();
                fieryBuildings[1].removeAllElements();
                fieryBuildings[2].removeAllElements();
                fieryBuildings[3].removeAllElements();

		while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			temp_building=(Building)the_world[WORLD_MODEL_BUILDING_INDEX].get(temp_index);
			fieryness=temp_building.get_fieryness();
			if (fieryness==MIN_SEVERE_BUILDING)
				num_ok++;
			else if (fieryness==BURNED_OUT_BUILDING)	
				num_burnt++;
			else if (fieryness<EXTINGUISHED_BUILDING1)
                        {
				num_burning++;	
                                if ( m_agent_type == CONNECT_FIRE_STATION && temp_building.get_assignedTo()<=0 )
                                {
                                        targets_tobe_saved.add(temp_building);
                                        fieryBuildings[fieryness].add(temp_building);
                                }
                        }
			//The rest of the buildings are extinguished!!!	
		}		

		
		result=(double)5.0 * (num_burnt*def_burnt_importance_rate + num_burning*def_burning_importance_rate)/(double)(the_world[WORLD_MODEL_BUILDING_INDEX].size()*def_burnt_importance_rate);	
		*/
                Building temp_building;
		Integer temp_index;
		int fieryness;                
                double result;
                double damaged_area = 0.0;
                double undamaged_area = 0.0;                
                Iterator it=the_world[WORLD_MODEL_BUILDING_INDEX].keySet().iterator();
                fieryBuildings[1].removeAllElements();
                fieryBuildings[2].removeAllElements();
                fieryBuildings[3].removeAllElements();
                
                while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			temp_building=(Building)the_world[WORLD_MODEL_BUILDING_INDEX].get(temp_index);
			fieryness=temp_building.get_fieryness();
		
			if (fieryness>MIN_SEVERE_BUILDING && fieryness<EXTINGUISHED_BUILDING1)
                        {
                                if ( m_agent_type == CONNECT_FIRE_STATION && temp_building.get_assignedTo()<=0 )
                                {
                                        targets_tobe_saved.add(temp_building);
                                        fieryBuildings[fieryness].add(temp_building);
                                }
                        }
                        if (fieryness<2)
				{
					undamaged_area += temp_building.m_buildingAreaTotal;
				}
                        else if (total_area == 0)
                                {
                                        damaged_area += temp_building.m_buildingAreaTotal;
                                }

		}	
                
                if (total_area == 0)
                                total_area = undamaged_area + damaged_area;
                                
                result = (total_area - undamaged_area) / total_area;     
                //* * * STATE CHANGE * * *//
                result *=4;     //Zooming into the lower 25% of the state scale
                
		if (result>1.0)
			result=1.0;
		return result;
	}
        
        final double fn_calculate_abstract_buildings(int m_agent_type)
	{
                /*
		int i;
		int num_burnt=0;
		int num_ok=0;
		Building temp_building;
		Integer temp_index;
		int fieryness;
		double result;

		num_burning=0;
		Iterator it=the_world[WORLD_MODEL_BUILDING_INDEX].keySet().iterator();
                fieryBuildings[1].removeAllElements();
                fieryBuildings[2].removeAllElements();
                fieryBuildings[3].removeAllElements();
                
		while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			temp_building=(Building)the_world[WORLD_MODEL_BUILDING_INDEX].get(temp_index);
			fieryness=temp_building.get_fieryness();
			if (fieryness==MIN_SEVERE_BUILDING)
				num_ok++;
			else if (fieryness==BURNED_OUT_BUILDING)	
				num_burnt++;
			else if (fieryness<EXTINGUISHED_BUILDING1)
                        {
				num_burning++;	
                                if (m_agent_type == CONNECT_FIRE_BRIGADE && saveable(temp_building))
                                {
                                        targets_tobe_saved.add(temp_building);        
                                        fieryBuildings[fieryness].add(temp_building);
                                }
                        }
			//The rest of the buildings are extinguished!!!	
		}		

		
		result=(double)5.0 * (num_burnt*def_burnt_importance_rate + num_burning*def_burning_importance_rate)/(double)(the_world[WORLD_MODEL_BUILDING_INDEX].size()*def_burnt_importance_rate);	
		*/
                Building temp_building;
		Integer temp_index;
		int fieryness;
                double result;                
                double damaged_area = 0.0;
                double undamaged_area = 0.0;               
                Iterator it=the_world[WORLD_MODEL_BUILDING_INDEX].keySet().iterator();
                fieryBuildings[1].removeAllElements();
                fieryBuildings[2].removeAllElements();
                fieryBuildings[3].removeAllElements();
                
                while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			temp_building=(Building)the_world[WORLD_MODEL_BUILDING_INDEX].get(temp_index);
			fieryness=temp_building.get_fieryness();
		
			if (fieryness>MIN_SEVERE_BUILDING && fieryness<EXTINGUISHED_BUILDING1)
                        {
                                if ( m_agent_type == CONNECT_FIRE_BRIGADE && saveable(temp_building))
                                {
                                        targets_tobe_saved.add(temp_building);
                                        fieryBuildings[fieryness].add(temp_building);
                                }
                               
                        }
			if (fieryness<2)
				{
					undamaged_area += temp_building.m_buildingAreaTotal;
				}
                        else if (total_area == 0)
                                {
                                        damaged_area += temp_building.m_buildingAreaTotal;
                                }

		}	
                
                if (total_area == 0)
                                total_area = undamaged_area + damaged_area;
                                
                result = (total_area - undamaged_area) / total_area;      
                
                //* * * STATE CHANGE * * *//
                result *=4;     //Zooming into the lower 25% of the state scale

                //System.out.println ("Unburned percent" + result + "total+area" + total_area + "undamaged_area" + undamaged_area);
		if (result>1.0)
			result=1.0;
		return result;
	}
        
        final double fn_calculate_abstract_peopleC(int m_agent_type)
	{
		int i;
		int num_of_civilians=0;
		double status_of_civilians=0;
		double last_hp=0;
                int living_civilians=0;

		MovingObject temp_civilian;
		Integer temp_index;
		double result;
		
		num_of_civilians=the_world[WORLD_MODEL_CIVILIAN_INDEX].size();
		
		
		Iterator it=the_world[WORLD_MODEL_CIVILIAN_INDEX].keySet().iterator();

		while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			temp_civilian=(MovingObject)the_world[WORLD_MODEL_CIVILIAN_INDEX].get(temp_index);
			if (!dead(temp_civilian))
                                living_civilians++;
			
			last_hp=temp_civilian.get_hp();
			status_of_civilians += last_hp;
			
			if (saveable(temp_civilian) && temp_civilian.m_position>0 ) 
			{
				num_injured++;      //Used in reporting the injured civilians        
                                if ( m_agent_type == CONNECT_AMBULANCE_CENTER &&  temp_civilian.get_assignedTo()<=0 )
                                        targets_tobe_saved.add(temp_civilian);

			}
					
		}		
		
		if (the_world[WORLD_MODEL_CIVILIAN_INDEX].size()>0)
                {
		        result = (double) living_civilians + ((double)status_of_civilians/(double)(the_world[WORLD_MODEL_CIVILIAN_INDEX].size()*MIN_SEVERE_CIVILIAN));
                        result /= (double) num_of_civilians + 1.0;
                        result = 1.0 - result;
                }
		else
			result=0.0;
			
		//System.out.println("Abstract civilians is calculated as: " + result);
		
		if (result>1.0)
			result=1.0;
                if (result<0.0)
                        result=0.0;
		return result;

	}
        
	final double fn_calculate_abstract_people(int m_agent_type)
	{
		int i;
		int num_of_civilians=0;
		double status_of_civilians=0;
		double last_hp=0;
                int living_civilians=0;
                
		MovingObject temp_civilian;
		Integer temp_index;
		double result;
		
		num_of_civilians=the_world[WORLD_MODEL_CIVILIAN_INDEX].size();
		
		
		Iterator it=the_world[WORLD_MODEL_CIVILIAN_INDEX].keySet().iterator();

		while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			temp_civilian=(MovingObject)the_world[WORLD_MODEL_CIVILIAN_INDEX].get(temp_index);
			
			
			last_hp=temp_civilian.get_hp();
			status_of_civilians += last_hp;
                        
                        if (!dead(temp_civilian))
                                living_civilians++;
			
			if (saveable(temp_civilian) && temp_civilian.m_position>0) 
			{
				num_injured++;
                                
                                if (m_agent_type == CONNECT_AMBULANCE_TEAM )
                                        targets_tobe_saved.add(temp_civilian);
			}
					
		}		
		
                
		if (the_world[WORLD_MODEL_CIVILIAN_INDEX].size()>0)
                { 
		        result = (double) living_civilians + ((double)status_of_civilians/(double)(the_world[WORLD_MODEL_CIVILIAN_INDEX].size()*MIN_SEVERE_CIVILIAN));
                        result /= (double) num_of_civilians + 1.0;
                        result = 1.0 - result;
                }
		else
			result=0.0;
			
		
		
		if (result>1.0)
			result=1.0;
                if (result<0.0)
                        result=0.0;
		return result;

	}
                                        
        final double fn_calculate_abstract_roadsC(int m_agent_type)
	{
		
		int i;
		
		Road temp_road;
		Integer temp_index;
		int repairCost;
		double result;
		
		num_blocked=0;
                num_blocked_w_civ=0;
		Iterator it=the_world[WORLD_MODEL_ROAD_INDEX].keySet().iterator();

		while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			
			//unconfirmed ones count as blocked!!!!!
			temp_road=(Road)the_world[WORLD_MODEL_ROAD_INDEX].get(temp_index);
			
			if (! clear(temp_road) || !(temp_road.confirmed))
			{
				num_blocked++;		
                                if (m_agent_type == CONNECT_POLICE_OFFICE && saveable(temp_road) && temp_road.get_assignedTo()<=0)
                                        targets_tobe_saved.add(temp_road);
			}
			
			if (!clear(temp_road) && positionsofMovingObjs.containsKey(temp_index))
			{
				num_blocked_w_civ++;	
			}
		}	
		
		//result=(double)num_blocked/(double)the_world[WORLD_MODEL_ROAD_INDEX].size();

                //* * * STATE CHANGE * * *//
                result=(double)(the_world[WORLD_MODEL_ROAD_INDEX].size() - ((the_world[WORLD_MODEL_ROAD_INDEX].size()-num_blocked)*4))/(double)the_world[WORLD_MODEL_ROAD_INDEX].size();
                
		if (result>1.0)
			result=1.0;
                if (result<0.0)        
                        result=0.0;
		return result;

	}
                                
                                        
	final double fn_calculate_abstract_roads(int m_agent_type)
	{
		
		int i;
		
		Road temp_road;
		Integer temp_index;
		int repairCost;
		double result;
		
		num_blocked=0;
                num_blocked_w_civ=0;
		Iterator it=the_world[WORLD_MODEL_ROAD_INDEX].keySet().iterator();

		while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			
			//unconfirmed ones count as blocked!!!!!
			temp_road=(Road)the_world[WORLD_MODEL_ROAD_INDEX].get(temp_index);
			
			if (! clear(temp_road) || !(temp_road.confirmed))
			{
				num_blocked++;	
                                if (m_agent_type == CONNECT_POLICE_FORCE && saveable(temp_road) && positionsofMovingObjs.containsKey(temp_index))
                                        targets_tobe_saved.add(temp_road);   
			}
			
		        if ( ! clear(temp_road) && positionsofMovingObjs.containsKey(temp_index))
			{
				num_blocked_w_civ++;	
			}
                             
		
		}	
		
		//result=(double)num_blocked/(double)the_world[WORLD_MODEL_ROAD_INDEX].size();

		 //* * * STATE CHANGE * * *//
                result=(double)(the_world[WORLD_MODEL_ROAD_INDEX].size() - ((the_world[WORLD_MODEL_ROAD_INDEX].size()-num_blocked)*4))/(double)the_world[WORLD_MODEL_ROAD_INDEX].size();
                
		if (result>1.0)
			result=1.0;
                if (result<0.0)        
                        result=0.0;
		return result;

	}
        
	final int get_current_state( byte m_agent_index, int m_agent_type)
	{
		double [] the_states;
	        int overall_state;
                
                //Update the abstract world also
                targets_tobe_saved.clear();
                
                if (m_agent_type == CONNECT_FIRE_STATION)
		        abstract_buildings=fn_calculate_abstract_buildingsC(m_agent_type);
                else
                        abstract_buildings=fn_calculate_abstract_buildings(m_agent_type);
                        
                if (m_agent_type == CONNECT_AMBULANCE_CENTER)
		        abstract_people=fn_calculate_abstract_peopleC(m_agent_type);
                else
                        abstract_people=fn_calculate_abstract_people(m_agent_type);
                        
                if (m_agent_type == CONNECT_POLICE_OFFICE)
		        abstract_roads=fn_calculate_abstract_roadsC(m_agent_type);
                else
                        abstract_roads=fn_calculate_abstract_roads(m_agent_type);
		
		
		the_states=new double[def_environment_types];

		if (m_agent_index==WORLD_MODEL_FIREFIGHTER_INDEX)
		{
			the_states[0]=abstract_buildings;
			the_states[1]=abstract_roads;
			the_states[2]=abstract_people;
		}
		else if(m_agent_index==WORLD_MODEL_POLICE_INDEX)
		{
			the_states[0]=abstract_roads;
			the_states[1]=abstract_buildings;
			the_states[2]=abstract_people;
		}
		else 
		{
			the_states[0]=abstract_people;
			the_states[1]=abstract_buildings;
			the_states[2]=abstract_roads;
		}
		
		
		the_states[0]=(int)((double)the_states[0]*(double)DEF_NUM_MY_LEVELS);
		the_states[1]=(int)((double)the_states[1]*(double)DEF_NUM_OTHER_LEVELS);
		the_states[2]=(int)((double)the_states[2]*(double)DEF_NUM_OTHER_LEVELS);
		
		if (the_states[0]==DEF_NUM_MY_LEVELS) the_states[0]--;
		if (the_states[1]==DEF_NUM_OTHER_LEVELS) the_states[1]--;
		if (the_states[2]==DEF_NUM_OTHER_LEVELS) the_states[2]--;
		
		overall_state= DEF_NUM_MY_LEVELS;
                overall_state *= ((int)the_states[1] * DEF_NUM_OTHER_LEVELS + (int)the_states[2] );
                overall_state += (int)the_states[0];
	
		return overall_state;
	}
	
////////////myController////////////////////////////////////////////////////////////////////////////////////////	
	final int myController(int agentType)
	{
		int controllertype;
		
		if (agentType==	CONNECT_FIRE_BRIGADE)
			controllertype=TYPE_FIRE_STATION;
		else if (agentType== CONNECT_AMBULANCE_TEAM)
			controllertype=TYPE_AMBULANCE_CENTER;
		else if (agentType== CONNECT_POLICE_FORCE)
			controllertype=TYPE_POLICE_OFFICE;
		else controllertype=-1;
		
		Iterator it=the_world[WORLD_MODEL_CONTROLLER_INDEX].keySet().iterator();
		Integer temp_index;
		SimObject temp_controller;

		while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			temp_controller=(SimObject)the_world[WORLD_MODEL_CONTROLLER_INDEX].get(temp_index);
			if (temp_controller.get_type()==controllertype)
				return temp_controller.get_id();
		}		
		return (int)-1;
	}


////////////memberOf////////////////////////////////////////////////////////////////////////////////////////
	final boolean memberOf(byte agentIndex, int agentId)
	{
	
		if (the_world[agentIndex].containsKey(new Integer (agentId)))
			return true;	
		else
			return false;
	
	}



////////////MAX SEVERITY///////////////////////////////////////////////////////////////////////////////////////////
//Returns null if it cannot be found
//Closest of the max severe building
	final SimObject findMaxSeverity_building(int m_x,int m_y, int current_time,Job current_target)
	{
		Building temp_building;
		SimObject max_object=null;
		double max_objects_distance=MY_MAXDOUBLE;
		double current_distance=MY_MAXDOUBLE;
                int i,j,arrSize;

		for (i=EXTINGUISHED_BUILDING1-1;i>0;i--)
                {
                        arrSize = fieryBuildings[i].size();      
                        for (j=0;j<arrSize; j++)
                        {
        			temp_building = (Building)fieryBuildings[i].get(j);
                                if (saveable(temp_building))
                                {  
                                        //Looking for a target other than the current         
                                        if (current_target !=null)
                                        {
                                                if (current_target.target_id == temp_building.m_id)
                                                        continue;
                                        }        
                                        
	               		        current_distance=lightDistance(temp_building, m_x, m_y);
		              		if (current_distance<max_objects_distance)
			             	{
				                max_object=(SimObject)temp_building;
                	                        max_objects_distance=current_distance;
				        }
                                }
                                else
                                {
                                        msgParser.writeMyFile(w_filename,"Not saveable and still in list" + temp_building.m_id + "time" + current_time);
                                        
                                }
			}
                        if (max_object != null)
                                return max_object;
		}		
		return max_object;
	}

	final SimObject findMaxSeverity_road(int m_x,int m_y, Job current_target)
	{
		Road temp_road;
		Integer temp_index;
		int block,i;
		int max_value=MIN_SEVERE_ROAD-1;
		SimObject max_object=null;
		double max_objects_distance=MY_MAXDOUBLE;
		double current_distance;

		for (i=0;i<targets_tobe_saved.size(); i++)
	        {
		        temp_road=(Road)targets_tobe_saved.get(i);
			temp_index=new Integer(temp_road.m_id);
		
                        if (current_target !=null)
                        {
                                if (current_target.target_id == temp_road.m_id)
                                        continue;
                        }

				//block=temp_road.get_block();
                                //repaircost == number of cycles required to clear 1,3,7 ....
                                //Extra severity == number of civilians on the road 1,3, ..
                                //Thus a valid measure
				block=temp_road.get_repairCost();
			
				if (block>0)
				{
					Integer extra_severity=(Integer)positionsofMovingObjs.get(temp_index);
					block+=extra_severity.intValue();
				}

				if (block>max_value)
				{	
					max_value=block;
					max_object=(SimObject)temp_road;
                                        max_objects_distance=lightDistance(temp_road, m_x, m_y);
				}
				else if (block==max_value)
				{
					current_distance=lightDistance(temp_road, m_x, m_y);
					if (current_distance<max_objects_distance)
					{
						max_object=(SimObject)temp_road;
						max_objects_distance=current_distance;
					}
				}
		
		}		
		return max_object;
	}

	final SimObject findMaxSeverity_civilian(Job current_target)
	{
		MovingObject temp_civilian;
		Integer temp_index;
		int hp,i;
		int max_value=MIN_SEVERE_CIVILIAN; //Min severe civilian is a highly positive value
		SimObject max_object=null;

		for (i=0;i<targets_tobe_saved.size(); i++)
	        {
		        temp_civilian=(MovingObject)targets_tobe_saved.get(i);
			temp_index=new Integer(temp_civilian.m_id);
                        
                        if (current_target !=null)
                        {
                                if (current_target.target_id == temp_civilian.m_id)
                                        continue;
                        }
                        
				hp=temp_civilian.get_hp() - (temp_civilian.get_damage() * temp_civilian.get_buriedness());
				if (hp<max_value)
				{	
					max_value=hp;
					max_object=(SimObject)temp_civilian;
				}

		}		
		return max_object;
	}

	final SimObject findMaxSeverity(int obj_index, int m_x, int m_y, int current_time, Job current_target)
	{
		
		SimObject max_object=null;

		if (obj_index==WORLD_MODEL_BUILDING_INDEX)		
			max_object=findMaxSeverity_building(m_x,m_y, current_time,current_target);
		if (obj_index==WORLD_MODEL_ROAD_INDEX)		
			max_object=findMaxSeverity_road(m_x,m_y,current_target);
		if (obj_index==WORLD_MODEL_CIVILIAN_INDEX)		
			max_object=findMaxSeverity_civilian(current_target);
		
		return max_object;
	}

//////////////MIN SEVERITY///////////////////////////////////////////////////////////////////////////////////////////

	final SimObject findMinSeverity_building(int m_x,int m_y, int current_time, Job current_target)
	{
		Building temp_building;
		SimObject min_object=null;
		double min_objects_distance=MY_MAXDOUBLE;
		double current_distance=MY_MAXDOUBLE;
                int i,j,arrSize;

		for (i = 1 ; i < EXTINGUISHED_BUILDING1 ; i++)
                {
                        arrSize = fieryBuildings[i].size();      
                        for (j = 0 ; j < arrSize ; j++)
                        {
        			temp_building = (Building)fieryBuildings[i].get(j);
                                
                                if (saveable(temp_building))
                                { 
                                        //Looking for a target other than the current         
                                        if (current_target !=null)
                                        {
                                                if (current_target.target_id == temp_building.m_id)
                                                        continue;
                                        }        
                                        
	               		        current_distance=lightDistance(temp_building, m_x, m_y);
		              		if (current_distance < min_objects_distance)
			             	{
				                min_object=(SimObject)temp_building;
                	                        min_objects_distance=current_distance;
				        }
                                }
                                else
                                {
                                         msgParser.writeMyFile(w_filename,"Not saveable and still in list min" + temp_building.m_id + " time " +  current_time);
                                }
			}
                        if (min_object != null)
                                return min_object;
		}		
		return min_object;
	}

	final SimObject findMinSeverity_road(int m_x,int m_y, Job current_target)
	{
		Road temp_road;
		Integer temp_index;
		int block,i;
		int min_value=MY_MAXINT;
		SimObject min_object=null;
		double min_objects_distance=MY_MAXDOUBLE;
		double current_distance;
		
		for (i=0;i<targets_tobe_saved.size(); i++)
	        {
		        temp_road=(Road)targets_tobe_saved.get(i);
                        temp_index=new Integer(temp_road.m_id);
		
                        if (current_target !=null)
                        {
                                if (current_target.target_id == temp_road.m_id)
                                        continue;
                        }
			
		
				//block=temp_road.get_block();
				block=temp_road.get_repairCost();
			        //repaircost == number of cycles required to clear 1,3,7 ....
                                //Extra severity == number of civilians on the road 1,3, ..
                                //Thus a valid measure     
				if (block>0 )
				{
					Integer extra_severity=(Integer)positionsofMovingObjs.get(temp_index);
					block+=extra_severity.intValue();
				}
				if (block<min_value)
				{	
					min_value=block;
					min_object=(SimObject)temp_road;
                                        min_objects_distance=lightDistance(temp_road, m_x, m_y);
				}
				else if (block==min_value)
				{
					current_distance=lightDistance(temp_road, m_x, m_y);
					if (current_distance<min_objects_distance)
					{
						min_object=(SimObject)temp_road;
						min_objects_distance=current_distance;
					}
				}
			
		}		
		return min_object;
	}

	final SimObject findMinSeverity_civilian( Job current_target)
	{
		MovingObject temp_civilian;
		Integer temp_index;
		int hp,i;
		int min_value=MAX_SEVERE_CIVILIAN-1	; //Equals -1 actually
		SimObject min_object=null;

		for (i=0;i<targets_tobe_saved.size(); i++)
	        {
		        temp_civilian=(MovingObject)targets_tobe_saved.get(i);
			temp_index=new Integer(temp_civilian.m_id);
			
                        if (current_target !=null)
                        {
                                if (current_target.target_id == temp_civilian.m_id)
                                        continue;
                        }
		
				hp=temp_civilian.get_hp() - (temp_civilian.get_damage() * temp_civilian.get_buriedness());

				
				if (hp>min_value)
				{	
					min_value=hp;
					min_object=(SimObject)temp_civilian;
				}
		
		}		
		return min_object;
	}

	final SimObject findMinSeverity(int obj_index,int m_x, int m_y, int current_time, Job current_target)
	{
		
		SimObject min_object=null;

		if (obj_index==WORLD_MODEL_BUILDING_INDEX)		
			min_object=findMinSeverity_building(m_x,m_y, current_time,current_target);
		if (obj_index==WORLD_MODEL_ROAD_INDEX)		
			min_object=findMinSeverity_road(m_x,m_y,current_target);
		if (obj_index==WORLD_MODEL_CIVILIAN_INDEX)		
			min_object=findMinSeverity_civilian(current_target);
		
		return min_object;
	}
////////MIN SEVERITY FOR CENTER///////////////////////////////////////////////////////////////////////////////////
//This one returns a vector containing equi-severe minimum severe targets

	final TargetDef findMinSeverity_buildingC(int current_time, byte agent_index)
	{
		Building temp_building;
		//Vector minsevere=new Vector();
                TargetDef tempTarget;
                TargetDef returnTarget = new TargetDef();
                int i,j,arrSize;
                double min_distance =  MY_MAXDOUBLE;
                
                for (i=1;i<EXTINGUISHED_BUILDING1;i++)
                {
                        arrSize = fieryBuildings[i].size();      
                        for (j=0;j<arrSize; j++)
                        {
        			temp_building = (Building)fieryBuildings[i].get(j);
                                if (temp_building.get_assignedTo()<=0)
                                {
	               		        //minsevere.add(new TargetDef(temp_building));
                                        tempTarget = findClosestAgentWM(agent_index,temp_building);
					if (tempTarget.agent!=null)
					{
						if (tempTarget.distance<min_distance)
						{
							min_distance=tempTarget.distance;
                                                        returnTarget.agent = tempTarget.agent;
							returnTarget.target = temp_building;
                                                        returnTarget.distance = tempTarget.distance;
						}
					}     
                                      
                                }      
			}
                        if (returnTarget.target != null)
                                return returnTarget;
		}	
                	
		return returnTarget;

	}

	final TargetDef findMinSeverity_roadC(byte agent_index)
	{
		Road temp_road;
                Integer temp_index;
		int block;
                int i;
		int min_value=MY_MAXINT;
		//Vector minsevere=new Vector();
                double min_distance =  MY_MAXDOUBLE;
                TargetDef tempTarget;
                TargetDef returnTarget = new TargetDef();
		
		for (i=0;i<targets_tobe_saved.size(); i++)
	        {
		      temp_road=(Road)targets_tobe_saved.get(i);

				//block=temp_road.get_block();
				block = temp_road.get_repairCost();
                                //repaircost == number of cycles required to clear 1,3,7 ....
                                //Extra severity == number of civilians on the road 1,3, ..
                                //Thus a valid measure
			        temp_index =new Integer(temp_road.m_id);
				if (block>0 && positionsofMovingObjs.containsKey(temp_index))
				{
					Integer extra_severity=(Integer)positionsofMovingObjs.get(temp_index);
					block+=extra_severity.intValue();
				}
                                
                                
                                if (block < min_value || block == min_value)
                                {
                                    tempTarget = findClosestAgentWM(agent_index,temp_road);
                		    if (tempTarget.agent!=null)
				    {
					if (tempTarget.distance<min_distance)
					{
                                                min_value=block;
						min_distance=tempTarget.distance;
                                                returnTarget.agent = tempTarget.agent;
					        returnTarget.target = temp_road;
                                                returnTarget.distance = tempTarget.distance;
					}
				    }    
				}
		}		
		return returnTarget;
	}

	final TargetDef findMinSeverity_civilianC(byte agent_index)
	{
		MovingObject temp_civilian;
		Integer temp_index;
		int hp;
                int i;
		int min_value=MAX_SEVERE_CIVILIAN-1; //Equals -1 actually
		//Vector minsevere=new Vector();
                double min_distance =  MY_MAXDOUBLE;
                TargetDef tempTarget;
                TargetDef returnTarget  = new TargetDef();
              
                
		for (i=0;i<targets_tobe_saved.size(); i++)
	        {
		      temp_civilian=(MovingObject)targets_tobe_saved.get(i);
		      temp_index = new Integer(temp_civilian.m_id);
		
		      hp=temp_civilian.get_hp() - (temp_civilian.get_damage() * temp_civilian.get_buriedness());

		      if ( hp>min_value || hp==min_value )
                      {                           
                              tempTarget = findClosestAgentWM(agent_index,temp_civilian);
                	      if (tempTarget.agent!=null)
			      {
				    if (tempTarget.distance<min_distance)
				    {
                                        min_value = hp;    
					min_distance=tempTarget.distance;
                                        returnTarget.agent = tempTarget.agent;
					returnTarget.target = temp_civilian;
                                        returnTarget.distance = tempTarget.distance;
				    }
		              }  
                      }
		}
			
		return returnTarget;
	}


//Assigns the least severe jobs to their closest agents, returns the one which has minimum agent-target distance
	final TargetDef findMinSeveritySet(int obj_index, byte agent_index, int current_time)
	{
		TargetDef min_target=new TargetDef();
	
		if (obj_index==WORLD_MODEL_BUILDING_INDEX)		
			min_target=findMinSeverity_buildingC(current_time, agent_index);
		if (obj_index==WORLD_MODEL_ROAD_INDEX)		
			min_target=findMinSeverity_roadC(agent_index);
		if (obj_index==WORLD_MODEL_CIVILIAN_INDEX)		
			min_target=findMinSeverity_civilianC(agent_index);
		
	        return min_target;
	}

////////MAX SEVERITY FOR CENTER///////////////////////////////////////////////////////////////////////////////////
//This one returns a vector containing equi-severe minimum severe targets

	final TargetDef findMaxSeverity_buildingC(int current_time, byte agent_index)
	{
		Building temp_building;
		//Vector maxsevere=new Vector();

                int i,j,arrSize;
                TargetDef tempTarget;
                TargetDef returnTarget = new TargetDef();
                double min_distance =  MY_MAXDOUBLE;
                
                for (i=EXTINGUISHED_BUILDING1-1;i>0;i--)
                {
                        arrSize = fieryBuildings[i].size();      
                        for (j=0;j<arrSize; j++)
                        {
        			temp_building = (Building)fieryBuildings[i].get(j);
                                if (temp_building.get_assignedTo()<=0)
                                {
	               		      //maxsevere.add(new TargetDef(temp_building));
                                      tempTarget = findClosestAgentWM(agent_index,temp_building);
					if (tempTarget.agent!=null)
					{
						if (tempTarget.distance<min_distance)
						{
							min_distance=tempTarget.distance;
                                                        returnTarget.agent = tempTarget.agent;
							returnTarget.target = temp_building;
                                                        returnTarget.distance = tempTarget.distance;
						}
					}  
                                }
			}
                        if (returnTarget.target != null)
                                return returnTarget;
		}	
                	
		return returnTarget;
	}

	final TargetDef findMaxSeverity_roadC(byte agent_index)
	{
		Road temp_road;
		Integer temp_index;
		int block;
		int i;
                int max_value=-1;
		//Vector maxsevere=new Vector();
		double min_distance =  MY_MAXDOUBLE;
                TargetDef tempTarget;
                TargetDef returnTarget = new TargetDef();
                
		for (i=0;i<targets_tobe_saved.size(); i++)
	        {
		      temp_road=(Road)targets_tobe_saved.get(i);
		      temp_index = new Integer(temp_road.m_id);

				//block=temp_road.get_block();
				block=temp_road.get_repairCost();
			        //repaircost == number of cycles required to clear 1,3,7 ....
                                //Extra severity == number of civilians on the road 1,3, ..
                                //Thus a valid measure
				if (block>0 && positionsofMovingObjs.containsKey(temp_index))
				{
					Integer extra_severity=(Integer)positionsofMovingObjs.get(temp_index);
					block+=extra_severity.intValue();
				}
                                if (block>max_value || block==max_value)
                                {
                                    tempTarget = findClosestAgentWM(agent_index,temp_road);
                		    if (tempTarget.agent!=null)
				    {
					if (tempTarget.distance<min_distance)
					{
                                                max_value=block;
						min_distance=tempTarget.distance;
                                                returnTarget.agent = tempTarget.agent;
					        returnTarget.target = temp_road;
                                                returnTarget.distance = tempTarget.distance;
					}
				    }    
				}
		
		}		
		return returnTarget;
	}

	final TargetDef findMaxSeverity_civilianC(byte agent_index)
	{
		MovingObject temp_civilian;
		Integer temp_index;
		int hp;
		int i;
                int max_value=MIN_SEVERE_CIVILIAN; //Min severe civilian is a highly positive value
		//Vector maxsevere=new Vector();
                double min_distance =  MY_MAXDOUBLE;
                TargetDef tempTarget;
                TargetDef returnTarget  = new TargetDef();

		for (i=0;i<targets_tobe_saved.size(); i++)
	        {
		      temp_civilian=(MovingObject)targets_tobe_saved.get(i);
		      temp_index = new Integer(temp_civilian.m_id);
		
		      hp=temp_civilian.get_hp() - (temp_civilian.get_damage() * temp_civilian.get_buriedness());
	
		      if ( hp<max_value ||hp==max_value )
                      {                           
                              tempTarget = findClosestAgentWM(agent_index,temp_civilian);
                	      if (tempTarget.agent!=null)
			      {
				    if (tempTarget.distance<min_distance)
				    {
                                        max_value=hp;    
					min_distance=tempTarget.distance;
                                        returnTarget.agent = tempTarget.agent;
					returnTarget.target = temp_civilian;
                                        returnTarget.distance = tempTarget.distance;
				    }
		              }  
                      }
		}		
		return returnTarget;
	}


//Assigns the least severe jobs to their closest agents, returns the one which has minimum agent-target distance
	final TargetDef findMaxSeveritySet(byte obj_index, byte agent_index, int current_time)
	{

		TargetDef min_target=null;
	
		if (obj_index==WORLD_MODEL_BUILDING_INDEX)		
			min_target=findMaxSeverity_buildingC(current_time, agent_index);
		if (obj_index==WORLD_MODEL_ROAD_INDEX)		
			min_target=findMaxSeverity_roadC(agent_index);
		if (obj_index==WORLD_MODEL_CIVILIAN_INDEX)		
			min_target=findMaxSeverity_civilianC(agent_index);
	
                return min_target;
	}

        
        
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	final TargetDef findClosestSet(int current_time, byte agent_index)
	{
	        SimObject temp_object;
		int i;
                double min_distance =  MY_MAXDOUBLE;
                TargetDef tempTarget;
                TargetDef returnTarget  = new TargetDef();

		for (i=0;i<targets_tobe_saved.size(); i++)
	        {
		      temp_object=(SimObject)targets_tobe_saved.get(i);

                              tempTarget = findClosestAgentWM(agent_index,temp_object);
                	      if (tempTarget.agent!=null)
			      {
				    if (tempTarget.distance<min_distance)
				    {
					min_distance=tempTarget.distance;
                                        returnTarget.agent = tempTarget.agent;
					returnTarget.target = temp_object;
                                        returnTarget.distance = tempTarget.distance;
				    }
		              }  
                      
		}		
		return returnTarget;
	}
        
////////////AT REFUGE/////////////////////////////////////////////////////////////////////////////////////////////
	final boolean atRefuge(MovingObject theObject)
	{
		Integer position;
		
		position=new Integer(theObject.get_position());
		if (the_world[WORLD_MODEL_REFUGE_INDEX].containsKey(position))
			return true;
		else 
			return false;
	}
////////////IN AMBULANCE//////////////////////////////////////////////////////////////////////////////////////////
	
	final boolean inAmbulance(MovingObject theObject)
	{
		Integer position;
		
		position=new Integer(theObject.get_position());
		if (the_world[WORLD_MODEL_AMBULANCE_INDEX].containsKey(position))
			return true;
		else 
			return false;
	}
        
//Burning buildings are kept in a different data structure, so their closest function is different
final SimObject FindClosestBurningBuilding(SimObject sourceObject,int numOfAssignedAgents, Job current_target)
{

        Building temp_building;
	SimObject closest_object=null;
	double closest_objects_distance=MY_MAXDOUBLE;
	double current_distance=MY_MAXDOUBLE;
        int i,j,arrSize;
        
        //If source object is a moving object we shall use its position in our distance calculations
	if (sourceObject instanceof MovingObject)
	{
		sourceObject=getObjectbyId(((MovingObject)sourceObject).get_position());
	
	}
	if (sourceObject==null || !(sourceObject instanceof StaticObject))
		return null;

	for (i=1;i<EXTINGUISHED_BUILDING1;i++)
        {
                arrSize = fieryBuildings[i].size();      
                for (j=0;j<arrSize; j++)
                {
                        temp_building = (Building)fieryBuildings[i].get(j);
                               
                        if (saveable(temp_building))       
                        {       
	               	       if ( temp_building.get_assignedTo()<numOfAssignedAgents)
	               	       {     
                                //Looking for a target other than the current         
                                if (current_target !=null)
                                {
                                        if (current_target.target_id == temp_building.m_id)
                                                continue;
                                }        
                                
                                current_distance=lightDistance((StaticObject)sourceObject,(StaticObject)temp_building);

		              	if (current_distance<closest_objects_distance)
			        {
				    closest_object=(SimObject)temp_building;
                	            closest_objects_distance=current_distance;
				}
                              }
                        }
                        else
                        {
                                msgParser.writeMyFile(w_filename,"Not saveable and still in list closest" + temp_building.m_id);
                        }
		}    
	}		
	return closest_object;

}
        

////////////CLOSEST///////////////////////////////////////////////////////////////////////////////////////////////
//Finds the closest object in destinationObjects to the sourceObject
//saveableOnly indicates the returned object must be saveable
//Called by ambulance for finding closest refuge
//Called by platoon for finding closest blocked road, or finding closest injured civilian location
final SimObject findClosest(Hashtable destinationObjects,SimObject sourceObject,boolean saveableOnly)
{
	double min_distance=MAX_DISTANCE;
	SimObject min_object=null;
	SimObject destinationObject=null;
	Integer temp_index;
	double distance;
	SimObject destinationAt=null;

	//If source object is a moving object we shall use its position in our distance calculations
	if (sourceObject instanceof MovingObject)
	{
		sourceObject=getObjectbyId(((MovingObject)sourceObject).get_position());
	
	}
	if (sourceObject==null || !(sourceObject instanceof StaticObject))
		return null;

	Iterator it=destinationObjects.keySet().iterator();
	while(it.hasNext())
	{
		temp_index=(Integer)it.next();
		destinationObject=(SimObject)destinationObjects.get(temp_index);
		
               	if ( !saveableOnly || saveable(destinationObject))
		{
			if (sourceObject.m_id != destinationObject.m_id )
			{
				//If destination object is a moving object we shall use its position in our distance calculations
				if (destinationObject instanceof MovingObject)
				{
					destinationAt=getObjectbyId(((MovingObject)destinationObject).get_position());
				}
				else
					destinationAt=destinationObject;
					
				if ( !(destinationAt instanceof StaticObject))
					continue;
				
				distance=lightDistance((StaticObject)sourceObject,(StaticObject)destinationAt);
			
				if (distance< min_distance)
				{	
					min_distance=distance;
					min_object=(SimObject)destinationObject;	
				}
			}
		}
	}
	
	return min_object;
}


//Finding the closest agent, used by the dispatcher
final SimObject findClosestAgent(byte m_agent_index,SimObject sourceObject)
{
	double min_distance=MAX_DISTANCE;
	SimObject min_object=null;
	SimObject destinationObject=null;
	Integer temp_index;
	double distance;
	SimObject destinationAt=null;
	
	//if (C_LOGGING) msgParser.writeMyFile(w_filename,"Findclosest called:" );
	
	//If source object is a moving object we shall use its position in our distance calculations
	if (sourceObject instanceof MovingObject)
	{
		sourceObject=getObjectbyId(((MovingObject)sourceObject).get_position());
	
	}
	if (sourceObject==null || !(sourceObject instanceof StaticObject))
		return null;
                        
        Iterator it=the_world[m_agent_index].keySet().iterator();
	while(it.hasNext())
	{
		temp_index=(Integer)it.next();
		destinationObject=(SimObject)the_world[m_agent_index].get(temp_index);
		//An agent should always have assignedto less than 1
		if (destinationObject.get_assignedTo()<=0)
		{
			//if (C_LOGGING) msgParser.writeMyFile(w_filename,"Findclosest calculating distance for:" + temp_index.intValue());
		
				destinationAt=getObjectbyId(((MovingObject)destinationObject).get_position());
					
				if ( ! (destinationAt instanceof StaticObject))
					continue;
                                        
                                if (sourceObject.m_id == destinationAt.m_id ) 
                                        continue;
				
				distance=lightDistance((StaticObject)sourceObject,(StaticObject)destinationAt);
			
				//if (C_LOGGING) msgParser.writeMyFile(w_filename,"Distance returned as:" + distance);
			
				if (distance< min_distance)
				{	
					min_distance=distance;
					min_object=(SimObject)destinationObject;	
				}
		
		}
	}
	
	return min_object;
}

//Finding the closest agent, used by the world model finding min/maxsevere for the dispatcher
final TargetDef findClosestAgentWM(byte m_agent_index,SimObject sourceObject)
{
	double min_distance=MAX_DISTANCE;
	SimObject min_object=null;
	SimObject destinationObject=null;
	Integer temp_index;
	double distance;
	SimObject destinationAt=null;
        TargetDef returnTarget;

        returnTarget = new TargetDef();
        
	//If source object is a moving object we shall use its position in our distance calculations
	if (sourceObject instanceof MovingObject)
	{
		sourceObject=getObjectbyId(((MovingObject)sourceObject).get_position());
	
	}
	if (sourceObject==null || !(sourceObject instanceof StaticObject))
		return null;
                        
        Iterator it=the_world[m_agent_index].keySet().iterator();
	while(it.hasNext())
	{
		temp_index=(Integer)it.next();
		destinationObject=(SimObject)the_world[m_agent_index].get(temp_index);
		//An agent should always have assignedto less than 1
		if (destinationObject.get_assignedTo()<=0)
		{
				destinationAt=getObjectbyId(((MovingObject)destinationObject).get_position());
					
				if ( ! (destinationAt instanceof StaticObject))
					continue;
                                        
                                if (sourceObject.m_id == destinationAt.m_id ) 
                                        continue;
				
				distance=lightDistance((StaticObject)sourceObject,(StaticObject)destinationAt);
			
				if (distance< min_distance)
				{	
					min_distance=distance;
                                        returnTarget.distance = distance;
                                        returnTarget.agent = (SimObject)destinationObject;
				}
		}
	}
	
	return returnTarget;
}

//Finding closest building, road or ambulance, used by dispatcher
final SimObject findClosestTarget(SimObject sourceObject,int numOfAssignedAgents, Job current_job)
{
	double min_distance=MAX_DISTANCE;
	SimObject min_object=null;
	SimObject destinationObject=null;
	double distance;
	SimObject destinationAt=null;
	int i;
        
	//If source object is a moving object we shall use its position in our distance calculations
	if (sourceObject instanceof MovingObject)
	{
		sourceObject=getObjectbyId(((MovingObject)sourceObject).get_position());
	
	}
	if (sourceObject==null || !(sourceObject instanceof StaticObject))
		return null;

		
	for (i=0;i<targets_tobe_saved.size(); i++)
	{
		destinationObject=(SimObject)targets_tobe_saved.get(i);
		
                if (current_job != null)
                {
                        if (current_job.target_id==destinationObject.m_id) continue;
                }
                
		//numOfAssignedAgents==MY_MAXINT when caller is an ordinary agent
		if (destinationObject.get_assignedTo()<numOfAssignedAgents)
		{
				//If destination object is a moving object we shall use its position in our distance calculations
				if (destinationObject instanceof MovingObject)
				{
					destinationAt=getObjectbyId(((MovingObject)destinationObject).get_position());
				}
				else
					destinationAt=destinationObject;
					
				if ( ! (destinationAt instanceof StaticObject))
					continue;
				
                                if (sourceObject.m_id == destinationAt.m_id)
                                        continue;
                                        
				distance=lightDistance((StaticObject)sourceObject,(StaticObject)destinationAt);
			
				//if (C_LOGGING) msgParser.writeMyFile(w_filename,"Distance returned as:" + distance);
			
				if (distance< min_distance)
				{	
					min_distance=distance;
					min_object=(SimObject)destinationObject;	
				}
		
		}
	}
	
	return min_object;
}

//For finding the closest building, road or ambulance, used by a platoon
final SimObject findClosestTarget(SimObject sourceObject, Job current_job)
{
	double min_distance=MAX_DISTANCE;
	SimObject min_object=null;
	SimObject destinationObject=null;
	double distance;
	SimObject destinationAt=null;
	int i;
        
	//If source object is a moving object we shall use its position in our distance calculations
	if (sourceObject instanceof MovingObject)
	{
		sourceObject=getObjectbyId(((MovingObject)sourceObject).get_position());
	
	}
	if (sourceObject==null || !(sourceObject instanceof StaticObject))
		return null;

		
	for (i=0;i<targets_tobe_saved.size(); i++)
	{
		destinationObject=(SimObject)targets_tobe_saved.get(i);
		
                if (current_job != null)
                {
                        if (current_job.target_id==destinationObject.m_id) continue;
                }
                
			//If destination object is a moving object we shall use its position in our distance calculations
			if (destinationObject instanceof MovingObject)
			{
				destinationAt=getObjectbyId(((MovingObject)destinationObject).get_position());
			}
			else
				destinationAt=destinationObject;
					
			if (! (destinationAt instanceof StaticObject))
				continue;
                                        
                        if (sourceObject.m_id == destinationAt.m_id)
                                continue;        
				
			distance=lightDistance((StaticObject)sourceObject,(StaticObject)destinationAt);
			
			//if (C_LOGGING) msgParser.writeMyFile(w_filename,"Distance returned as:" + distance);
			
			if (distance< min_distance)
			{	
				min_distance=distance;
				min_object=(SimObject)destinationObject;	
			}
	}
	
	return min_object;
}

//Called by the random target decision module, for finding buildings and refuges
final SimObject findClosestExcept(Hashtable destinationObjects,SimObject sourceObject,boolean saveableOnly,Vector except_for)
{
	double min_distance=MAX_DISTANCE;
	SimObject min_object=null;
	SimObject destinationObject=null;
	Integer temp_index;
	double distance;
	SimObject destinationAt=null;
	
	//If source object is a moving object we shall use its position in our distance calculations
	if (sourceObject instanceof MovingObject)
	{
		sourceObject=getObjectbyId(((MovingObject)sourceObject).get_position());
	
	}
	if (sourceObject==null || !(sourceObject instanceof StaticObject))
		return null;

	Iterator it=destinationObjects.keySet().iterator();
	while(it.hasNext())
	{
		temp_index=(Integer)it.next();
		destinationObject=(SimObject)destinationObjects.get(temp_index);
		
		if ((!saveableOnly || saveable(destinationObject)) && !except_for.contains(temp_index))
		{
			//If destination object is a moving object we shall use its position in our distance calculations
			if (destinationObject instanceof MovingObject)
			{
				destinationAt=getObjectbyId(((MovingObject)destinationObject).get_position());
			}
			else
				destinationAt=destinationObject;
					
			if ( ! (destinationAt instanceof StaticObject))
				continue;
				
                        if (sourceObject.m_id == destinationAt.m_id)
                                continue;
                                        
			distance=lightDistance((StaticObject)sourceObject,(StaticObject)destinationAt);
			
			//if (C_LOGGING) msgParser.writeMyFile(w_filename,"Distance returned as:" + distance);
			
			if (distance< min_distance)
			{	
				min_distance=distance;
				min_object=(SimObject)destinationObject;	
			}	
		}
	}
	
	return min_object;
}

//If max levels is reached in routefinder, then closest node in the latest level is searched
final RouteNode findClosestRouteNode(Hashtable destinationObjects,SimObject sourceObject)
{
	double min_distance=MAX_DISTANCE;
	RouteNode min_object=null;
	SimObject destinationObject;
	RouteNode routeObject;
	Integer temp_index;
	double distance;
	
	//If source object is a moving object we shall use its position in our distance calculations
	if (sourceObject instanceof MovingObject)
	{
		sourceObject=getObjectbyId(((MovingObject)sourceObject).get_position());
	
	}
        if (! (sourceObject instanceof StaticObject))
        {
                return null;
        }

	Iterator it=destinationObjects.keySet().iterator();
	while(it.hasNext())
	{
		temp_index=(Integer)it.next();
		routeObject=(RouteNode)destinationObjects.get(temp_index);
		destinationObject=routeObject.theNodeObject;
		
		if (! (destinationObject instanceof StaticObject))
			continue;
				
		distance=lightDistance((StaticObject)sourceObject,(StaticObject)destinationObject);
			
		if (R_LOGGING) msgParser.writeMyFile(w_filename,"findClosestRouteNode:Distance returned as:" + distance);
					
		if (distance< min_distance)
		{	
			min_distance=distance;
			min_object=(RouteNode)routeObject;	
		}
	}
	
	return min_object;
}


//If no route is found in routefinder, the blocked roads is searched for the closest one to end position(passed in sourceObject)
final SimObject closestForRandomRoute(Vector destinationObjects,SimObject sourceObject)
{
	double min_distance=MAX_DISTANCE;
	SimObject min_object=null;
        BlockedRoad road_object=null;
	SimObject destinationObject=null;
	double distance;
        int i;
	
	//If source object is a moving object we shall use its position in our distance calculations
	if (sourceObject instanceof MovingObject)
	{
		sourceObject=getObjectbyId(((MovingObject)sourceObject).get_position());
	
	}
        if (! (sourceObject instanceof StaticObject))
                return null;

	for (i=0; i<destinationObjects.size(); i++)
	{
		road_object=(BlockedRoad)destinationObjects.get(i);
		destinationObject=road_object.blocked_road;
                if (!(destinationObject instanceof StaticObject))
        	       continue;
                //If there is no other chance we allow roads at level 1
                if (road_object.level == 1 && min_object == null )
                        min_object=destinationObject;
                else
                {	
        		distance=lightDistance((StaticObject)sourceObject,(StaticObject)destinationObject);
			
        		if (R_LOGGING) msgParser.writeMyFile(w_filename,"Distance returned as:" + distance);
			
        		if (distance< min_distance)
        		{	
        			min_distance=distance;
        			min_object=(SimObject)destinationObject;	
	        	}	
                }
	}
	
	return min_object;
}

////////////FIND REAL ANY //////////////////////////////////////////////////////////////////////////////
////////////Returns a random target to the random target finder module /////////////////////////////////
	final SimObject findRealAny(Hashtable objHash,SimObject current_pos, Vector ExcludeVector)
	{
		SimObject temp_object;
		int random_size;

		Vector targetObjects=new Vector (objHash.values());
                random_size = targetObjects.size();
                
		
                while (random_size>0)
                {
                      //System.out.println ("Agent " + m_id + "random target loop position: " + current_pos.m_id );
                      int random_index=(int)Math.floor((randomgen.nextFloat()*(double)(random_size)));
                      if (random_index == random_size) random_index--;
                
                      temp_object = (SimObject) targetObjects.get(random_index);
           
		      //Random target is one that has not been visited before, and not adjacent to our current position		
		      if (notAdjacent (temp_object.m_id, current_pos) && !(ExcludeVector.contains(new Integer(temp_object.m_id))))
                            return temp_object;
                      else
                            targetObjects.remove(random_index);
                            
                      random_size = targetObjects.size();
		}
                
                
		return null;
	}	

/////////////findMinSevere_buildingAround/////////////////////////////////////////////////////////////////////////////////
/////////////Called by platoon agents when looking for closest burning building
final StaticObject findMinSevere_buildingAround( int ExcludeThis, int m_x, int m_y)
{
	Building temp_object;
	Integer temp_index;
	int fieryness=0;
	int min_val=MY_MAXINT;	
        double min_distance =  MAX_DISTANCE;
        double current_distance;
	Building min_object=null;
		
        Iterator it=objectsAroundHere.keySet().iterator();        
	while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			if ( temp_index.intValue()!=ExcludeThis && the_world[WORLD_MODEL_BUILDING_INDEX].containsKey(temp_index) )
			{
				temp_object=(Building)objectsAroundHere.get(temp_index);
				
				if (saveable(temp_object) && withinExtDist(temp_object,m_x, m_y))
				{
					fieryness=temp_object.get_fieryness();
              
					if (fieryness<min_val)
					{
						min_val=fieryness;
						min_object=temp_object;	
                                                min_distance = lightDistance(temp_object, m_x, m_y);
					}
                                        else if (fieryness == min_val)
                                        {
                                                current_distance = lightDistance(temp_object, m_x, m_y);
                                                if (current_distance <  min_distance)
                                                {
                                                     min_val = fieryness;
						     min_object = temp_object;	
                                                     min_distance = current_distance;
                                                }
                                        }
						
				}	
			}	
		}
	return min_object;
}        

////////////FIND ONLY/////////////////////////////////////////////////////////////////////////////////////////////
	final SimObject findOnly()
	{      
                return (SimObject)targets_tobe_saved.get(0);
	}        

	final boolean withinExtDist(StaticObject target, int m_x, int m_y)
	{	
		boolean result=distance(target,m_x,m_y) < FIREFIGHTER_EXTINGUISHABLE_DISTANCE;
	
		return  ( result);
	}
	
       
        final double lightDistance(int startx,int starty,int endx,int endy)
        {    	
		double xdist;
		double ydist;
		
		xdist=(double)endx-startx;
		ydist=(double)endy-starty;
		
		return (xdist*xdist+ydist*ydist);
        }

	final double distance(int startx,int starty,int endx,int endy)
	{
		
		double xdist;
		double ydist;
		
		xdist=(double)(endx-startx);
		ydist=(double)(endy-starty);
		
		return (Math.sqrt(xdist*xdist+ydist*ydist));
	}
	
        
        final double lightDistance (SimObject sourceObject,SimObject destinationObject)
	{
		StaticObject sourceAt=null;
		StaticObject destinationAt=null;
	
		if (sourceObject instanceof MovingObject)
		{
			sourceAt=(StaticObject)getObjectbyId(((MovingObject)sourceObject).get_position());
		}
		else
			sourceAt=(StaticObject)sourceObject;
		
		if (destinationObject instanceof MovingObject)
		{
			destinationAt=(StaticObject)getObjectbyId(((MovingObject)destinationObject).get_position());
		}
		else
			destinationAt=(StaticObject)destinationObject;
			
		return lightDistance(sourceAt,destinationAt);
	}
        
	final double distance (SimObject sourceObject,SimObject destinationObject)
	{
		StaticObject sourceAt=null;
		StaticObject destinationAt=null;
	
		if (sourceObject instanceof MovingObject)
		{
			sourceAt=(StaticObject)getObjectbyId(((MovingObject)sourceObject).get_position());
		}
		else
			sourceAt=(StaticObject)sourceObject;
		
		if (destinationObject instanceof MovingObject)
		{
			destinationAt=(StaticObject)getObjectbyId(((MovingObject)destinationObject).get_position());
		}
		else
			destinationAt=(StaticObject)destinationObject;
			
		return distance(sourceAt,destinationAt);
	}
	
        final double lightDistance(StaticObject sourceObject,StaticObject destinationObject)
	{
		StaticObject sourceAt=sourceObject;
		StaticObject destinationAt=destinationObject;
			
		if (sourceObject instanceof Road)
		{
			sourceAt= (StaticObject)getObjectbyId(((Road)sourceObject).get_head());
		}
		if (destinationObject instanceof Road)
		{
			destinationAt= (StaticObject)getObjectbyId(((Road)destinationObject).get_head());
		}
	  	return lightDistance(sourceAt.get_x(),sourceAt.get_y(), destinationAt.get_x(), destinationAt.get_y());
	}

	final double distance(StaticObject sourceObject,StaticObject destinationObject)
	{
		StaticObject sourceAt=sourceObject;
		StaticObject destinationAt=destinationObject;
			
		if (sourceObject instanceof Road)
		{
			sourceAt= (StaticObject)getObjectbyId(((Road)sourceObject).get_head());
		}
		if (destinationObject instanceof Road)
		{
			destinationAt= (StaticObject)getObjectbyId(((Road)destinationObject).get_head());
		}
	  	return distance(sourceAt.get_x(),sourceAt.get_y(), destinationAt.get_x(), destinationAt.get_y());
	}

        final double lightDistance(StaticObject sourceObject, int endx, int endy)
	{
                
                StaticObject sourceAt=sourceObject;
                if (sourceObject instanceof Road)
		{
                        //System.out.println("Road lightdistance makul hesaplandi"); //This check is done OK
			sourceAt= (StaticObject)getObjectbyId(((Road)sourceObject).get_head());
		}
		return lightDistance(sourceAt.get_x(), sourceAt.get_y(), endx, endy);
	}

	final double distance(StaticObject sourceObject, int endx, int endy)
	{ 
                StaticObject sourceAt=sourceObject;
                if (sourceObject instanceof Road)
		{
                        msgParser.writeMyFile(w_filename,"Road distance makul hesaplandi");
			sourceAt= (StaticObject)getObjectbyId(((Road)sourceObject).get_head());
		}
		return distance(sourceAt.get_x(), sourceAt.get_y(), endx, endy);
	}

	final boolean notAdjacent(int theId, SimObject thePosition)
	{
			
		if (thePosition.get_id()==theId) 
		{
			//if (IS_LOGGING) msgParser.writeMyFile(w_filename,"Returning false!");
			return false;
		}
		if (thePosition instanceof Node)
		{
			int i;
			int [] edges;
			edges=((Node)thePosition).get_edges();
		
			for (i=0;i<edges.length;i++)
			{
				if (edges[i]==theId) return false;
			}
		
		}
		return true;
	}
        
////////////DUMMY REFUGE///////////////////////////////////////////////////////////////////////////////////////////////
	final int findDummyRefuge()
	{
	
		Iterator it=the_world[WORLD_MODEL_REFUGE_INDEX].keySet().iterator();

		if(it.hasNext())
		{
			return (((Integer)it.next()).intValue());
				
		}

		return -1;
	}

////////////BURNING/////////////////////////////////////////////////////////////////////////////////////////////////
	final boolean burning(SimObject object)
	{
		return  (((Building)object).get_fieryness()>MIN_SEVERE_BUILDING  && ((Building)object).get_fieryness()<=MAX_SEVERE_BUILDING );
		
	}

////////////NOT BURNING/////////////////////////////////////////////////////////////////////////////////////////////////
	final boolean notBurning(SimObject object)
	{
		return (((Building)object).get_fieryness()==MIN_SEVERE_BUILDING);
		
	}

////////////BURNT DOWN////////////////////////////////////////////////////////////////////////////////////////////////
	final boolean burntDown(SimObject object)
	{
		return (((Building)object).get_fieryness()>=BURNED_OUT_BUILDING);
	
	}

////////////EXTINGUISHED//////////////////////////////////////////////////////////////////////////////////////////////

	final boolean extinguished(SimObject object)
	{
		int fieryness;
		
		fieryness=((Building)object).get_fieryness();
	
		return (fieryness==EXTINGUISHED_BUILDING1 || fieryness==EXTINGUISHED_BUILDING2|| fieryness==EXTINGUISHED_BUILDING3);
		
	}
////////////HEALTHY///////////////////////////////////////////////////////////////////////////////////////////////
	final boolean healthy(SimObject object)
	{
		return  (((MovingObject)object).get_hp()==MIN_SEVERE_CIVILIAN);
	}

////////////DEAD//////////////////////////////////////////////////////////////////////////////////////////////////
	final boolean dead(SimObject object)
	{
		return (((MovingObject)object).get_hp()==MAX_SEVERE_CIVILIAN);
	}

////////////CLEAR/////////////////////////////////////////////////////////////////////////////////////////////////
	final boolean clear(SimObject object)
	{
		return (((Road)object).get_block()==MIN_SEVERE_ROAD);
	}


////////////SAVEABLE/////////////////////////////////////////////////////////////////////////////////////////////////
	final boolean saveable(SimObject object)
	{
		
		if (object instanceof Road)
		{
			return (!clear(object) && !(ingoredJobsofPolice.contains(new Integer(object.m_id))));
		}
		else if (object instanceof MovingObject)
		{
			return ( ! healthy(object) && !dead(object) && !atRefuge((MovingObject)object) && !inAmbulance((MovingObject)object));
		}
		else if (object instanceof Building)
		{
			return (burning(object));
		}
		else 
			return false;
	}

////////////PASSABLE//////////////////////////////////////////////////////////////////////////////////////////////
	final boolean passable(SimObject object, SimObject startnode)
	{
	
		//EDGE MUST BE INSTANCE OF ROAD, IF ITS BUILDING RETURN TRUE IMMEDIATELY,IF RIVER RETURN FALSE
		if (object instanceof Road)
		{
			if 	(((Road)object).get_head()==startnode.get_id() && ((Road)object).get_aliveLinesToTail()>0) 
				{	
					//if (W_LOGGING) msgParser.writeMyFile(w_filename," Passable: to Tail:"+((Road)object).get_aliveLinesToTail());
					return true;
				}
			else if (((Road)object).get_tail()==startnode.get_id() && ((Road)object).get_aliveLinesToHead()>0) 
				{
					//if (W_LOGGING) msgParser.writeMyFile(w_filename," Passable: to Head:"+((Road)object).get_aliveLinesToHead());
					return true;
				}	
			else 
				return false;
		}
		else if(object instanceof River)
			return false;
		else
			return true;
		
	}
	
        final boolean passable(SimObject object, SimObject startnode, double PosExtra)
	{
	
		//EDGE MUST BE INSTANCE OF ROAD, IF ITS BUILDING RETURN TRUE IMMEDIATELY,IF RIVER RETURN FALSE
                //If posExtra<=length/2 and lane blocked, you have to change lanes: Traffic simulator
		if (object instanceof Road)
		{
			if 	(((Road)object).get_head()==startnode.get_id() && (((Road)object).get_aliveLinesToTail()>0 || PosExtra>(((Road)object).get_length()/2) ))
				{	
					if (W_LOGGING) msgParser.writeMyFile(w_filename," Passable: to Tail:"+((Road)object).get_aliveLinesToTail());
                                        //if (((Road)object).get_aliveLinesToTail()<=0)
                                        //        System.out.println("Yehoo new passable criteria is useful." + object.get_id());
					return true;
				}
			else if (((Road)object).get_tail()==startnode.get_id() && (((Road)object).get_aliveLinesToHead()>0  || PosExtra<(((Road)object).get_length()/2) ))
				{
					if (W_LOGGING) msgParser.writeMyFile(w_filename," Passable: to Head:"+((Road)object).get_aliveLinesToHead());
                                        //if (((Road)object).get_aliveLinesToHead()<=0)
                                        //        System.out.println("Yehoo new passable criteria is useful." + object.get_id());

					return true;
				}	
			else 
				return false;
		}
		else if(object instanceof River)
			return false;
		else
			return true;
		
	}
	
////////////getObjectbyId 1-2/////////////////////////////////////////////////////////////////////////////////////

	final SimObject getObjectbyId(int obj_id, byte obj_type_index)
	{
		return (SimObject)the_world[obj_type_index].get(new Integer(obj_id));
	}

	final SimObject getObjectbyId(int obj_id)
	{
		int i;
		Integer search_id;

		search_id=new Integer(obj_id);

		for(i=0;i<the_world.length;i++)
		{
			if(the_world[i].containsKey(search_id))
				return (SimObject) the_world[i].get(search_id);
		}

		return null;
	}

////////////targetIsHere//////////////////////////////////////////////////////////////////////////////////////////

	//We have seen the target in last cycle
        //Used by the ambulanceTeam
	final boolean targetIsHere(int theObject)
	{
		return (objectsAroundHere.containsKey(new Integer(theObject)));
		
	}
			
////////////isRoad////////////////////////////////////////////////////////////////////////////////////////////////	

        //Is the position of the target a road
        //Used by the ambulanceTeam
	final boolean isRoad(int id)
	{
		return the_world[WORLD_MODEL_ROAD_INDEX].containsKey(new Integer(id));
	}
	
	
////////////CLEAR ASSIGNED TO OF//////////////////////////////////////////////////////////////////////////////////
	
        //Called by the controllerThd when receiving a reply from an agent
	final void clearAssignedToOf(int objId,byte objType)
	{
		Hashtable objHash;
		SimObject theObject;
                
		objHash=the_world[objType];
		theObject=(SimObject)objHash.get(new Integer(objId));
		theObject.m_assignedTo=0;
		//Interestingly enough this is enough, get is done by reference
		//Thus the copy in the hashtable is updated automatically
	}
        
        
        
        final int getRewardDivisor(int objId,byte objType)
        {
		Hashtable objHash;
		SimObject theObject;
                
		objHash=the_world[objType];
		theObject=(SimObject)objHash.get(new Integer(objId));
		return theObject.m_assignedTo;
	}
	
////////////findACivilianToReport/////////////////////////////////////////////////////////////////////
//////ALL AGENTS CALL THIS FOR REPORTING CIVILIANS////////////////////////////////////////////////////
	final MovingObject findACivilianToReport()
	{
		Hashtable objHash;
		MovingObject theObject;
		Integer temp_index;		

		objHash=the_world[WORLD_MODEL_CIVILIAN_INDEX];
		Iterator it=objHash.keySet().iterator();
		
		while(it.hasNext())
		{
			temp_index=(Integer)it.next();
			theObject=(MovingObject)objHash.get(temp_index);
		
			if (theObject.get_position()>0  && theObject.get_assignedTo()<=0 && saveable(theObject))
			{
				theObject.m_assignedTo=1;
				return theObject;	
			}
		
		}
		return null;
	}
	
////////////UPDATE WORLD//////////////////////////////////////////////////////////////////////////////////////////
	
	final void updateWorld(int objId, byte objType,int objStatus)
	{
		Hashtable objHash;
		SimObject theObject;		

		objHash=the_world[objType];
		theObject=(SimObject)objHash.get(new Integer(objId));
		
		if (theObject instanceof Building)
			((Building)theObject).m_fieryness=objStatus;
		else if (theObject instanceof Road)
		{
			((Road)theObject).m_repairCost=objStatus;
			((Road)theObject).m_block=objStatus;
			((Road)theObject).confirmed=true;
		}
		else if (theObject instanceof MovingObject)
			((MovingObject)theObject).m_hp=objStatus;
	}



	final SimObject createSimObject(int objType)
	{
		SimObject result = null;
    		switch (objType) {
    	
    			case TYPE_BUILDING:         result = new Building();         break;
    			case TYPE_CIVILIAN:         result = new Civilian();         break;
    			case TYPE_CAR:              result = new Car();              break;
    			case TYPE_FIRE_BRIGADE:     result = new FireFighter();      break;
    			case TYPE_FIRE_STATION:     result = new FireStation();      break;
    			case TYPE_AMBULANCE_TEAM:   result = new Ambulance();        break;
    			case TYPE_AMBULANCE_CENTER: result = new AmbulanceCenter();  break;
    			case TYPE_POLICE_FORCE:     result = new PoliceOfficer();    break;
    			case TYPE_POLICE_OFFICE:    result = new PoliceStation();    break;
    			case TYPE_REFUGE:           result = new Refuge();           break;
    			case TYPE_ROAD:             result = new Road();             break;
   	 		case TYPE_RIVER:            result = new River();            break;
    			case TYPE_NODE:             result = new RoadNode();         break;
    			case TYPE_RIVER_NODE:       result = new RiverNode();        break;
			case TYPE_WORLD:       		result = new World();	         break;
    			default:
                                msgParser.writeMyFile(w_filename,"--- failed in ObjectPool.newRescueObject(). Unknown object type: "+objType);
      				result = null;
      				break;
    			}
		result.m_type=objType;
    		return result;	
	}

        final boolean notOurself (int i)
        {
               return (i!=MSG_FORMAT_SENSE_OBJECT+1);
        }
        
	final void parseKA_SENSE(int [] message_body, int current_time) throws java.io.IOException
	{
		oldAroundHere=(Hashtable)objectsAroundHere.clone();
		objectsAroundHere.clear();	//Clear the objects around us
		//This function does not handle the first two integer fields, it only handles the self object and environment objects, KA_SENSE and KA_CONNECT_OK differ only in these two fields
		
		parser_i=MSG_FORMAT_SENSE_OBJECT;		//Initialize the index to the first object definition
		parser_j=-1;
                parser_object_type=(int)message_body[MSG_FORMAT_SENSE_OBJECT];

                parser_world_index = -1;
                parser_prop_type = -1;
                parser_object_id = -1;
                parser_current_object = null;
                
		while(parser_object_type!=TYPE_NULL)
		{
			parser_object_id=(int)message_body[++parser_i];
                        
			//Look for the object in the current vectors
			//If not found create a new object			
 			
			switch (parser_object_type)
			{
				case TYPE_BUILDING:
					parser_world_index=WORLD_MODEL_BUILDING_INDEX;
					break;
				case TYPE_ROAD:
					parser_world_index=WORLD_MODEL_ROAD_INDEX;
					//System.out.println("Road's ID " + object_id);
					break;
				case TYPE_CIVILIAN:
					parser_world_index=WORLD_MODEL_CIVILIAN_INDEX;
					break;
				case TYPE_FIRE_BRIGADE:
					parser_world_index=WORLD_MODEL_FIREFIGHTER_INDEX;
					break;
				case TYPE_POLICE_FORCE:
					parser_world_index=WORLD_MODEL_POLICE_INDEX;
					break;
				case TYPE_AMBULANCE_TEAM:
					parser_world_index=WORLD_MODEL_AMBULANCE_INDEX;
					break;
				case TYPE_FIRE_STATION:case TYPE_POLICE_OFFICE:case TYPE_AMBULANCE_CENTER:
					parser_world_index=WORLD_MODEL_CONTROLLER_INDEX;
					break;
				case TYPE_REFUGE:
					parser_world_index=WORLD_MODEL_REFUGE_INDEX;
					break;
				default:
					parser_world_index=WORLD_MODEL_OTHER_INDEX;
					break;
			}


			//If we already know about the object, we get its info
			if (the_world[parser_world_index].containsKey(new Integer(parser_object_id)))
			{
				parser_current_object=(SimObject)the_world[parser_world_index].get(new Integer(parser_object_id));
			}
			//If not, we create the object and add it to our hashtables
			else
			{
				parser_current_object=createSimObject(parser_object_type);
				parser_current_object.set_id(parser_object_id);
				the_world[parser_world_index].put(new Integer(parser_object_id), parser_current_object);
				
				//We are putting the moving agents to the civilians set so that they can be saved	
				if (parser_world_index==WORLD_MODEL_FIREFIGHTER_INDEX || parser_world_index==WORLD_MODEL_POLICE_INDEX || (parser_world_index==WORLD_MODEL_AMBULANCE_INDEX && notOurself(parser_i)))
				{
					if (AMB_LOGGING) msgParser.writeMyFile(w_filename,"civilian olarak agent ekledik" + parser_object_id);
					//System.out.println("civilian olarak agent ekledik" + object_id);
					the_world[WORLD_MODEL_CIVILIAN_INDEX].put(new Integer(parser_object_id), parser_current_object);
					
				}
				//After this point, the changes in the object are reflected to the one in hashtable
				//The 'put' command is done by reference...
				
				//INITIALIZE THE ASSIGNED TO FIELD OF THE OBJECTS
				parser_current_object.set_assignedTo((int)0);
			}
			
			parser_prop_type=message_body[++parser_i];
					
			while (parser_prop_type!=PROPERTY_NULL)
			{	
				
				//send the index of the first element containing the value as input
				if (parser_prop_type<0x80 || parser_prop_type>0xFF)
				{ 
					//parser_i=getSingleValue(message_body,++parser_i,parser_current_object,parser_prop_type, current_time);		//single value		
				        ++parser_i;
                                        parser_value= new int[1];
                                        parser_value[0] = message_body[parser_i];
		
                                        boolean printed=false;
		                             
                                              //STEPS_BLOCK_ARRIVE=5 and first blocked roads arrive at time 6: measured and justified 8/12/2002
		                              if (parser_prop_type==PROPERTY_REPAIR_COST && current_time>STEPS_BLOCK_ARRIVE)       
		                              {		
			                             ((Road)parser_current_object).confirmed=true;  //Agent receives info on only the roads it sees, thus we set confirmed to true
		                              }
                
		                              if (parser_prop_type==PROPERTY_POSITION && (parser_current_object instanceof MovingObject) && m_id!=0 && parser_current_object.m_id!=m_id)  //Last two conditions check that the moving object is not ourself
			                             handleMovingObjectPositions((MovingObject)parser_current_object, new Integer(parser_value[0]));
		                              
                                              /*BURASI ESKIDEN BUILDING FIERINESS ARRAYLERINI UPDATE ICIN KULLANILIYORDU
                                              if (parser_prop_type==PROPERTY_FIERYNESS && (parser_current_object instanceof Building))
		                              {
                                                        C
                                                     
                                                        if (fieryness != parser_value[0])
                                                        {
                                                            if (parser_value[0]>=EXTINGUISHED_BUILDING1)
                                                           {
                                                                    if (X_LOGGING) msgParser.writeMyFile(w_filename,"---Building now unsaveable " + parser_current_object.m_id + "time " + current_time);                                        
                                                            }
                        
                                                           if (fieryness>0 && fieryness<EXTINGUISHED_BUILDING1)
                                                           {
                                                                    fieryBuildings[fieryness].remove(parser_current_object);
                                                            }
                                
                                                            if (parser_value[0]>0 && parser_value[0]<EXTINGUISHED_BUILDING1)
                                                            {
                                                                    fieryBuildings[parser_value[0]].add(parser_current_object);
                                                           }
                
                                                     }
			
	                               	       }*/
                                               
                                               if (parser_prop_type==PROPERTY_FIERYNESS && (parser_current_object instanceof Building))
                                               {
                                                   //If the building was not on fire, if it is now and if we have not reported it before    
                                                   if (((Building)parser_current_object).m_fieryness == 0 && parser_value[0]>0 && ((Building)parser_current_object).m_fire_reported==0 )
                                                   {
                                                        buildings_tobe_reported.add(parser_current_object);
                                                        //System.out.println ("Agent " + m_id + " added building " + parser_current_object.m_id + " to the report list.");
                                                   }
                                       
                                               }
                                               
	                               	parser_current_object.setproperty(parser_prop_type,parser_value);
	                               	parser_i =  parser_i+1;
                                
                                }
				else if (parser_prop_type < 0xC0)
				{ 
					 //parser_i=getListofValues(message_body,++parser_i,parser_current_object,parser_prop_type);		//list of values
                                      
                                        ++parser_i;
		                        parser_arrsize=message_body[parser_i]/4;
		                        parser_value=new int[parser_arrsize];
                                        
		                        System.arraycopy(message_body,parser_i+1,parser_value,0,parser_arrsize);
		                        parser_current_object.setproperty(parser_prop_type,parser_value);
	
		                        parser_i =  parser_i + 1 + parser_arrsize ;	//size+array itself        
                                         
                                }         
				else 
				{  
					 //parser_i=getListofIDs(message_body,++parser_i,parser_current_object,parser_prop_type);			//list of IDs
                                         
                                        ++parser_i;
                                        
		                        for (parser_arrsize=0;message_body[parser_i+parser_arrsize]!=ID_NULL;parser_arrsize++);//Arrsize found
		                        parser_value=new int[parser_arrsize];
		                        
		                        System.arraycopy(message_body,parser_i,parser_value,0,parser_arrsize);
		                        parser_current_object.setproperty(parser_prop_type,parser_value);
	
		                        parser_i =  parser_i+ parser_arrsize + 1;		//array + last 0        
                                         
                                }         
				parser_prop_type=message_body[parser_i];  //Property functions return next i
			
			}

			objectsAroundHere.put(new Integer(parser_object_id),parser_current_object);
			
			parser_object_type=(int)message_body[++parser_i];	
			
		}
		
			handleObjectsOutofScope(objectsAroundHere, oldAroundHere);
	}
/*
	//Gets a single-valued property and returns the position in the msg_array
	final int getSingleValue(int [] message_body,int current_index, SimObject current_object,int prop_type, int current_time) //throws java.io.IOException
	{
		int [] value= {message_body[current_index]};
		
                boolean printed=false;
		if (prop_type==PROPERTY_REPAIR_COST && value[0]>0 && !printed)
                {
                        System.out.println("Block arrives, time: " + current_time);
                        printed=true;
                }
                
		if (prop_type==PROPERTY_REPAIR_COST && current_time>STEPS_BLOCK_ARRIVE)       
		{		
			((Road)current_object).confirmed=true;  //Agent receives info on only the roads it sees, thus we set confirmed to true
		}
                
		if (prop_type==PROPERTY_POSITION && (current_object instanceof MovingObject) && m_id!=0 && current_object.m_id!=m_id)  //Last two conditions check that the moving object is not ourself
			handleMovingObjectPositions((MovingObject)current_object, new Integer(value[0]));
		if (prop_type==PROPERTY_FIERYNESS && (current_object instanceof Building))
		{
                        int fieryness=((Building)current_object).m_fieryness;
                        
                        //Not used anymore 8/12/2002
                   
		//	if (fieryness==0 && value[0]!=0)
		//	{
		//		((Building)current_object).m_fire_start_time=current_time;
		//	}
                       
                        
                        if (fieryness != value[0])
                        {
                                if (value[0]>=EXTINGUISHED_BUILDING1)
                                {
                                        if (X_LOGGING) msgParser.writeMyFile(w_filename,"---Building now unsaveable " + current_object.m_id + "time " + current_time);                                        
                                }
                        
                                if (fieryness>0 && fieryness<EXTINGUISHED_BUILDING1)
                                {
                                        fieryBuildings[fieryness].remove(current_object);
                                }
                                
                                if (value[0]>0 && value[0]<EXTINGUISHED_BUILDING1)
                                {
                                        fieryBuildings[value[0]].add(current_object);
                                }
                
                        }
			
		}
		current_object.setproperty(prop_type,value);
		return current_index+1;
	}
	

	final int getListofValues(int [] message_body,int current_index, SimObject current_object,int prop_type) throws java.io.IOException
	{
		int arrsize;
		int [] value;

		arrsize=message_body[current_index]/4;
		value=new int[arrsize];
		System.arraycopy(message_body,current_index+1,value,0,arrsize);
		current_object.setproperty(prop_type,value);
	
		return current_index + 1 + arrsize ;	//size+array itself
	}

	final int getListofIDs(int [] message_body,int current_index, SimObject current_object,int prop_type) throws java.io.IOException
	{
		int arrsize;
		int [] value;

		for (arrsize=0;message_body[current_index+arrsize]!=ID_NULL;arrsize++);//Arrsize found
		value=new int[arrsize];
		
		System.arraycopy(message_body,current_index,value,0,arrsize);
		current_object.setproperty(prop_type,value);
	
		return current_index+arrsize+1;		//array + last 0
	}
*/	
	final void handleMovingObjectPositions(MovingObject current_object, Integer new_position)
	{
	
		//If the object has changed position, we have to decrement the count of old position
		if (current_object.m_position!=new_position.intValue())
		{
			Integer old_position;
			old_position=new Integer(current_object.m_position);			
			if (positionsofMovingObjs.containsKey(old_position))
			{
				Integer old_count;
				old_count=(Integer) positionsofMovingObjs.remove(old_position);
				old_count= new Integer(old_count.intValue()-1);
				if (GEN_LOGGING) msgParser.writeMyFile(w_filename,"Decreasing count of posn: " + old_position.intValue() + " for object " + current_object.m_id + " count:" + old_count.intValue());
				if (old_count.intValue() > 0 )
				{
					positionsofMovingObjs.put(old_position, old_count);
					if (GEN_LOGGING) msgParser.writeMyFile(w_filename,"Removing: " + old_position.intValue() + " for object " + current_object.m_id);
				}
			}
			if (positionsofMovingObjs.containsKey(new_position))
			{
				Integer new_count;
				new_count=(Integer) positionsofMovingObjs.remove(new_position);
				new_count= new Integer(new_count.intValue()+1);
                                positionsofMovingObjs.put(new_position, new_count);
				if (GEN_LOGGING) msgParser.writeMyFile(w_filename,"Increasing count of posn: " + new_position.intValue() + " for object " + current_object.m_id + " count: " + new_count.intValue() );

			}
			else
			{
				positionsofMovingObjs.put(new_position, new Integer(1));
				if (GEN_LOGGING) msgParser.writeMyFile(w_filename,"Adding: " + new_position.intValue() + " for object " + current_object.m_id);
			}
		}
	
	}
	
	final void handleObjectsOutofScope(Hashtable objectsAroundHere, Hashtable oldAroundHere)
	{
		Integer temp_index;
		SimObject temp_object;
		Iterator it=oldAroundHere.keySet().iterator();

		while(it.hasNext())
			{
				temp_index=(Integer)it.next();
				temp_object=(SimObject)oldAroundHere.get(temp_index);
				
				if (temp_object instanceof MovingObject)
				{
					//If the object we have seen before has moved out of our scope, remove it from posns
					if (!(objectsAroundHere.containsKey(temp_index)))
					{

						Integer old_count;
						old_count=(Integer) positionsofMovingObjs.remove(new Integer(((MovingObject)temp_object).get_position()));
						if (old_count!=null)
						{
							old_count= new Integer(old_count.intValue()-1);
                                                        
							if (old_count.intValue() != 0 )
							{
								positionsofMovingObjs.put(new Integer(((MovingObject)temp_object).get_position()),old_count);
							}
							if (GEN_LOGGING) msgParser.writeMyFile(w_filename,"Removing object out of scope: " + temp_index.intValue() + " for position " + ((MovingObject)temp_object).get_position());
						}					
					}
				}
			}
	}
}


class TargetDef
{
	SimObject target;
	double distance;
	SimObject agent;

        TargetDef()
	{
		target=null;
		distance=-1;
		agent=null;
	}
        
	TargetDef(SimObject x_target)
	{
		target=x_target;
		distance=-1;
		agent=null;
	}	
}

